      program cnttau2
C..............................................................July 2016
C add cycle on 76 stations for current month
c	
c	  count Tau=TEC/NmF2, rv
C Input: (1) styrmnt.txt
C        (2) styrmn.txt
C Output:(1) styrmns.txt	 !slab-thickness Tau
C	   
      DIMENSION IM(12),ff2(0:23),tec(0:23)
	INTEGER*4 JRES(0:23)
	CHARACTER*128 INFILE1,INFILE2,OUTFILE,TXT,INDATE
	CHARACTER*2 st(74),stcode,yy,amn
	CHARACTER*6	YRMNDY
	CHARACTER*4	YEAR
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA ST/
	+ 'as','at','bp','bc','br','cn','cb','cw','ch','cq'
     +,'cr','cs','dw','db','ea','eb','eg','ei','gm','gr'
     +,'gu','gg','ha','he','ho','ic','if','jj','jm','jr'
     +,'kg','kk','lg','lm','lv','mg','mq','ml','mw','mo'
     +,'mm','nc','nd','ni','ns','ok','pa','ps','pe','pq'
     +,'qn','rm','ro','rv','mb','sd','sq','so','tk','tr'
     +,'tv','tz','vt','wk','wp','wz','yg','yk'
     +,'kh','di','al','au','ff','ga'/
C-     +,'kh','au','ff','al'/
	
C Test
      indate='d:\web\graf\date'       ! Tamara
	open(10,file=indate,action='READ')
	 read(10,14) YEAR,AMN
	close(unit=10)
C
	YEAR='2017'
	AMN='02' ! TEMP
	outfile='d:\web\graf\dat9\15\styrmns.txt'  ! Tamara
	infile1='d:\web\graf\dat1\15\styrmn.txt'   ! Tamara
	infile2='d:\web\graf\dat7\15\styrmnt.txt'  ! Tamara
C 
	YY=YEAR(3:4)
   14	FORMAT(A4,1X,A2,3X,A4,1X,A2)
   15	FORMAT(A4)
	outfile(18:19)=yy
	outfile(23:24)=yy
	outfile(25:26)=amn
	infile1(18:19)=yy
	infile1(23:24)=yy
	infile1(25:26)=amn
	infile2(18:19)=yy
	infile2(23:24)=yy
	infile2(25:26)=amn

  200 continue
  199	format(A2)
CREM	do 300 jsta=1,72
	do 300 jsta=1,74
	stcode=st(jsta)
	ieof=0
	write(*,*) stcode
	 OUTFILE(21:22)=stcode
	infile1(21:22)=stcode
	infile2(21:22)=stcode
c     
	OPEN(11,FILE=INFILE1)				  ! file foF2
	OPEN(12,FILE=INFILE2)				  ! file TEC
	OPEN(13,FILE=OUTFILE)				  ! Tau
C
  201	continue
	read(amn,*) rmn
	mn=int(rmn)
	read(yy,*) yr
	iy=int(yr)
	z1=yr/4.
	jz=int(z1)*4
	IF(jz.EQ.iy) THEN
               IM(2)=29
					dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF

  220 L=0   
      JFL=0 
  159	format(A6,2X,24(F3.1,2X))
  160	format(A128)
  161	format(A6,24(1X,F4.1))
  162	format(A6,24(1X,I4))

C Read-write title lines:
	do k=1,4
	read (11,160,err=270,end=300) txt      ! title
	read (12,160,err=270,end=300) txt      ! title
	if (k.eq.1) txt(15:17)='Tau'
	write(*,160) txt
	write(13,160) txt
	enddo
	ndnr=im(mn)
C Day-to-day cycle:
	DO 260 idy=1,ndnr
   	read (11,159,err=270,end=300) YRMNDY,(ff2(k),k=0,23)      ! file foF2
      read (12,161,err=270,end=300) YRMNDY,(tec(k),k=0,23)      ! file foF2
	do 10 i=0,23
	 xnm=ff2(i)*ff2(i)*1.24
	if (xnm.eq.0.) then
	write(*,*) infile1,YRMNDY,i,' Enter missed foF2:'
	read(*,*) fof2
	 xnm=fof2*fof2*1.24
c	pause ' '

c	rtau=1000.
c	goto 11
	endif

      if (xnm.gt.0.) then
		rtau=tec(i)/xnm
	else
	rtau=0.999
	endif
   11	 jres(i)=nint(rtau*1000.)
   10	continue
	write(*,162) YRMNDY,(jres(k),k=0,23)
	write(13,162) YRMNDY,(jres(k),k=0,23)
  260	continue
	goto 300
  270	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY ',infile1,infile2

  300	CONTINUE
	goto 301

  301	close(unit=11)
	close(unit=12)
	close(unit=13)
	pause ' '
      STOP
	end