	program extcme1
C .......................................................Nov. 2018
C Extract daily max Scmi linear speed day-by-day (Year-by-year)
C CME-all.txt  Including Halo results
c for 1996-2017/10.......................................................
C
c
	DIMENSION IM(12)
	CHARACTER*64 infile,outfile
      CHARACTER*128 txt,txtmax,txt_nex
	CHARACTER*2 AMN,ADY,CYR,CMN,CDY,CYR_nex,CMN_nex,CDY_nex
	CHARACTER*4 AYEAR,CYEAR,VCME,CYEAR_nex
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
   31 format(A128)
C
	iyyyy=1995
	infile='CME-all.txt'
	outfile='CME-all1.res'
C
      OPEN(11,FILE=INFILE,action='READ')
      OPEN(12,FILE=OUTFILE)
C
      do i=1,3
	read(11,31) txt ! extra line
	write(12,31) txt
	enddo
C
C start cycle on Year
      scmi=0.
 100	iyyyy=iyyyy+1
C
C	if (iyyyy.gt.2017) goto 900 ! total result =>

	year=float(iyyyy)
	if(int(year/4.)*4.eq.iyyyy) THEN 
	ndnr=366
	im(2)=29
	                          ELSE
	ndnr=365
	im(2)=28
	ENDIF
	deldy=1./ndnr

C
	call blet4(iyyyy,AYEAR)
C
C	AYR=ayear(3:4)
C	iyr=iyyyy-(iyyyy/100)*100
C
C
200   continue	  !
      
	imnend=12
	if (iyyyy.eq.2017) imnend=10 !(20015/07)
C
C start  mn-to-mn cycle >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      lda=0
C
      DO 1234	imn=1,imnend
C		
	call blet2(imn,AMN)
	imndys=im(imn)
C
C day-to-day cycle
C
      kdy_pre=0
      DO 234 idy=1,imndys
	call blet2(idy,ADY)
	lda=lda+1
C  Input data
C
C Date       Time     Central  Width  Linear   2nd order speed      Accel     Mass      Kinetic    MPA   Remarks
C1996/01/22  03:11:01    105     37    267     401    130      0   -126.3*   7.1e+13*   2.5e+28*   103   Very Poor Event; Only C3
      vmax=0.
c    1	READ (11,31,END=55,ERR=2) txt
    1	READ (11,31,END=55,ERR=2) txt
      i=index(txt,'Halo')
	if (i.gt.0) THEN
	txt(i:i+3)='-360'
C--	GOTO 1
	ENDIF
C Check next SMI line
	READ (11,31,END=55,ERR=2) txt_nex
	backspace(11)

      CYEAR=txt(1:4)
	CYR=CYEAR(3:4)
	CMN=txt(6:7)
	CDY=txt(9:10)
	CYEAR_nex=txt_nex(1:4)
	CYR_nex=CYEAR_nex(3:4)
	CMN_nex=txt_nex(6:7)
	CDY_nex=txt_nex(9:10)
	READ(cyr,*) Rcyr
	KYR=INT(rcyr)
	READ(cmn,*) Rcmn
	KMN=INT(rcmn)
	READ(cdy,*) Rcdy
	KDY=INT(rcdy)
	READ(cyr_nex,*) Rcyr_nex
	KYR_nex=INT(rcyr_nex)
	READ(cmn_nex,*) Rcmn_nex
	KMN_nex=INT(rcmn_nex)
	READ(cdy_nex,*) Rcdy_nex
	KDY_nex=INT(rcdy_nex)
	klda=ndoy(kyr,kmn,kdy)
	klda_nex=ndoy(kyr_nex,kmn_nex,kdy_nex)
	if ((klda_nex.lt.klda).and.(CYEAR.ne.AYEAR)) 
     +	klda_nex=ndnr+klda_nex
C
C?	if (CYEAR.ne.AYEAR) then
C?	backspace(11)
C?	goto 100
C?	endif
C
C?      if (CMN.ne.AMN) then
C?	backspace(11)
C? 	goto 1234
C?	endif
C
C/	READ(cdy,*) Rcdy
C/	KDY=INT(rcdy)
C Check next day
C
C      if (kdy.gt.idy) then
      if (klda.gt.lda) then
	backspace(11)                ! kdy > idy
	goto 234
	endif 
C
C
C	if (kdy.eq.idy) then	!+ ++++++++++++++++++++++++
	if (klda.eq.lda) then	!+ ++++++++++++++++++++++++
C
231	VCME=txt(38:41)
	IF (VCME.eq.'----') THEN 
	goto 1
	ENDIF
C
	if (VCME(1:1).eq.' ') VCME(1:1)='0'
      if (VCME(2:2).eq.' ') VCME(2:2)='0'
	if (VCME(3:3).eq.' ') VCME(3:3)='0'
	read(VCME,*) rvcme
	    if (rvcme.gt.vmax) then  !++
	    vmax=rvcme
	    txtmax=txt
	    endif					 !++
C	   if (kdy_nex.gt.kdy) then   !+++
	   if (klda_nex.gt.klda) then   !+++
	goto 233
	else					!+++
          goto 1
	endif					 !+++
	              ELSE
	backspace(11) 
	                  ENDIF   !++++++++++++++++
C
   33	format(1X,F9.4,1X,A128)
C Output results
  233 CONTINUE
C day-of-year
C
	doy=iyyyy+deldy*(lda-1)
	write(*,33) doy,txtmax
	write(12,33) doy,txtmax
C
  234 CONTINUE
C
1234	CONTINUE ! End of monthly file
      if (iyyyy.lt.2018) GOTO 100
  55   CLOSE(unit=11)
       CLOSE(unit=12)
C
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

