	program extcmepch
C .......................................................Nov. 2018
C Calculate annual median max Vcmi & add Pch daily (Year-by-year)
C
c for 1996-2017/10.......................................................
C
c
	DIMENSION IM(12),CC(366)
	CHARACTER*64 infile1,infile2,outfile1,outfile2
      CHARACTER*128 txt
	CHARACTER*2 AYR,AMN,ADY,CYR,CMN,CDY,BYR,BMN,BDY
	CHARACTER*4 AYEAR,CYEAR
	COMMON /BL1/CC
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/

C
   31 format(A128)
C
	iyyyy=1995
	infile1='CME-all1.res'  ! including Halo
	infile2='pchdata.dat'
	outfile1='CME-Pch.res'
	outfile2='CMEmedyr.txt'
	delmon=1./12.
C
      OPEN(11,FILE=INFILE1,action='READ')
	 OPEN(13,FILE=INFILE2,action='READ')
      OPEN(12,FILE=OUTFILE1) ! daily Vcme & Pch
	OPEN(14,FILE=OUTFILE2) ! annual mean Vcme
C
      do i=1,3
	read(11,31) txt ! extra line
	write(*,31) txt
	enddo
C
C start cycle on Year
 100	iyyyy=iyyyy+1
C
C	if (iyyyy.gt.2017) goto 900 ! total result =>
      scmi=0.
	icnt=0
	ndy=0
	year=float(iyyyy)
	if(int(year/4.)*4.eq.iyyyy) THEN 
	ndnr=366
	im(2)=29
	                          ELSE
	ndnr=365
	im(2)=28
	ENDIF
C
	call blet4(iyyyy,AYEAR)
C
	AYR=ayear(3:4)
	iyr=iyyyy-(iyyyy/100)*100
C
200   continue	  !
      
C
C start  day-to-day cycle >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
      DO 1234	lda=1,ndnr  ! 
C		
C
C  Input data
C
   32	format(1X,F9.4,1X,A4,2(1X,A2),27X,I4)
C                                   PA           Speed  initial final   20R                        Energy                                   
C 1996.0270 1996/01/11  00:14:36    267     18    499     571    426      0    -64.3*   -------    -------    272   Only C3                 
    1	READ (11,32,END=222,ERR=2) RYEAR,CYEAR,CMN,CDY,kcme

      CYR=CYEAR(3:4)
	kyear=int(RYEAR)
	KYR=kyear-(kyear/100)*100
	READ(cmn,*) Rcmn
	KMN=INT(rcmn)
	READ(cdy,*) Rcdy
	KDY=INT(rcdy)
	klda=ndoy(kyr,kmn,kdy)
	IF ((CYR.eq.AYR).and.(klda.eq.lda)) THEN		 !1+
	icnt=icnt+1
	CC(icnt)=float(kcme)
	scmi=scmi+CC(icnt)  ! 
C
      if (kyear.ge.2011) then 						! 2++
	   if ((kyear.eq.2011).and.(kmn.lt.4)) goto 1234
C  Extract Pch:
  234 CONTINUE
      read(13,33,end=55,err=2) jyr,jmn,jdy,pch
C
	  if ((jyr.eq.kyr).and.(jmn.eq.kmn).and.(jdy.eq.kdy)) then !3+++
C Output daily data
	  write(*,34) RYEAR,CMN,CDY,kcme,pch
	  write(12,34) RYEAR,CMN,CDY,kcme,pch
	  goto 1234
	                                          else		   ! 3+++
	  goto 234
	  endif												   ! 3+++
                                  endif         ! 2++

C//	if (kyear.lt.2011) goto 1234                
C
C 110320  336.25
   33	format(1X,3(I2),1X,F7.2)
   34	format(1X,F8.3,2(1X,A2),1X,I4,1X,F7.2)
   35	format(1X,F8.3,1X,F6.2)
                                           ELSE  ! 1++
              backspace(11)
C
                                                   ENDIF    ! 1+
C
1234	CONTINUE ! End of day-to-day cycle
C
C annual median
C
  222     call submed366(icnt,resmed)
C
      yeardec=year+delmon*(kmn-1)
	write(*,35) yeardec,resmed
	write(14,35) yeardec,resmed
      if (iyyyy.lt.2017) GOTO 100
  55   CLOSE(unit=11)
       CLOSE(unit=12)
C
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

