	program extdias4m
C...........................................................Dec 2020
C Add reading Moscow Archive Parus data + Add Sverdlovsk
C  TLG......................................................Aug 2016
C
c  EXTRACT foF2 & M3000F2 FROM DAILY-HOURLY FILE DIAS stations 
C 
	DIMENSION im(12),f107(12)
	+,jf2(0:23),jh2(0:23),jm3(0:23),aff(0:23,4),amm(0:23,4),ahm(0:23,4)
     	INTEGER*2 jyr,jmn,jdy,idy,idy1,idy2

C    !type declaration
C      type STAT
        CHARACTER*2 st,CC(0:23)
C        integer :: jyr,jmn,jdy,jut
        real glat,glon
      end type STAT
C
	CHARACTER*128 infile1,infile2,infile3,outfilef,outfilem,outfileh
	+,infmos,infcov
 	CHARACTER*4 YEAR,CYEAR,BYEAR
	+,fof
	CHARACTER*5 xfNAN,xmNAN
	CHARACTER*6 mos 
	CHARACTER*49 txt
	CHARACTER*9 m3f
	CHARACTER*4 hmf
	CHARACTER*3 xhNAN
	CHARACTER*2 AYR,AMN,ST,DY1,DY2,ADY
	+,CMN,CYR,CDY
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/

C START===============================================================
C   !declaring type variables
      type (STAT) :: at 
C-      type (STAT) :: wz 
      type (STAT) :: so 
      type (STAT) :: sv 
      at%glat = 38.4
      at%glon =23.6
c-      wz%glat = 52.2
c-      wz%glon =21.1
      so%glat = 67.4
      so%glon =26.6
      sv%glat = 56.4
      sv%glon =58.6

C 
      WRITE(*,*)' ENTER <YEAR> OF INPUT FILE :'
crem 	READ(*,198) YEAR
	YEAR='2020'
crem	YEAR='2002'
C++
C read F107_12
	infcov='f107_12.dat'
	OPEN(10,file=infcov,action='READ')
      read(10,*) id,imx,iyr
     	read(10,*) im1,iyr1,im2,iyr2
    1	read(10,*) BYEAR,txt
	IF (BYEAR.eq.YEAR) then
	backspace(10)
	goto 92
	else
	goto 1
	ENDIF
   30	format(1X,A4,1X,12(1X,F5.1))
   92	read(10,30,end=70) BYEAR,(f107(k),k=1,12)
   70   close(unit=10)
C
 198	format(A40)
	      WRITE(*,*)' ENTER <MN> OF INPUT FILE :'
  	READ(*,199) AMN
C+	AMN='07'
	      WRITE(*,*)' ENTER <DY1>,<DY2> :'
  	READ(*,199) DY1,DY2
C+	dy1='01'
C+	dy2='30' !temp
C+	idy1=1
C+	idy2=30
	read(DY1,*) rdy1
	idy1=int(rdy1)
	read(DY2,*) rdy2
	idy2=int(rdy2)
 197	format(2(1X,A4,2(1X,A2)),1X,A2)

  200	 WRITE(*,*)' ENTER STATION-CODE OF INPUT FILE <ST>:'
 	READ(*,199) st
C++
       AYR=YEAR(3:4)
C	if ((st.eq.'mo').or.(st.eq.'tk')) goto 333
	if (st.eq.'tk') goto 333
	if (st.eq.'wz') then
Crem	call subextwz1(YEAR,AMN,DD2,AMN_pre,ADY_pre)
	call subextwz2(YEAR,AMN,DY2,AMN,DY1,COV)
	goto 333
	endif
C
C++
c	st='at'     !TEMP
  199	format(A2)
C ==========================================================
C
	read(ayr,*) ryr
	jyr=int(ryr)
	read(amn,*) rmn
	jmn=int(rmn)
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
	cov=f107(jmn)

	do i=1,4
	do k=0,23
	aff(k,i)=0.0
	amm(k,i)=0.0
	ahm(k,i)=0.0
	enddo
	enddo
C
C ==========================================================
      count=0
      infile1='d:/web/graf/ST/stYRMNDYf.txt'		 !TLG
	infile1(18:19)=AYR
	infile1(13:14)=ST
	infile1(16:17)=ST
	infile1(20:21)=AMN
	infile2=infile1
	infile2(24:24)='m'
	infile3=infile1
	infile3(24:24)='h'
C

C      OPEN(33,FILE=infile)
	outfilef='d:/web/graf/YEAR/stYRf.br'		 !TLG
      outfilef(13:16)=YEAR
	outfilef(18:19)=ST
	outfilef(20:21)=AYR
	outfilem=outfilef
	outfilem(22:22)='m'
	outfileh=outfilef
	outfileh(22:22)='h'
C Sve
	if (st.eq.'sv') then
	infile1=outfilef
	infile1(10:10)='i'	
	infile2=outfileh
	infile2(10:10)='i'	
	infile3=outfilem	
	infile3(10:10)='i'		
	endif

C Mos
      infmos=infile1
	infmos(24:28)='     '

C EOF before to-day:
	OPEN(33,file=OUTFILEF)
	icount=0
	m_strings=0
  201	read(33,198,end=204) txt
	CYR=txt(1:2)
	CMN=txt(3:4)
	CDY=txt(5:6)
	if ((cyr.eq.ayr).and.(cmn.eq.amn).and.(cdy.eq.dy1)) then
 	goto 204
	                  else
         icount=icount+1
      GOTO 201
      CONTINUE
                  	endif
  204 m_strings = icount
	REWIND (33)
      icount=0
C
      do while (icount.lt.m_strings)
         READ(33, 198, END=203) txt
         icount=icount+1
      enddo
  203 print*,'YES!'
      ENDFILE 33
      close(UNIT=33)

C EOF before to-day:
	OPEN(33,file=OUTFILEM)
	icount=0
	m_strings=0
  202	read(33,198,end=205) txt
	CYR=txt(1:2)
	CMN=txt(3:4)
	CDY=txt(5:6)
	if ((cyr.eq.ayr).and.(cmn.eq.amn).and.(cdy.eq.dy1)) then
 	goto 205
	                  else
         icount=icount+1
      GOTO 202
      CONTINUE
                  	endif
  205 m_strings = icount
	REWIND (33)
      icount=0
C
      do while (icount.lt.m_strings)
         READ(33, 198, END=445) txt
         icount=icount+1
      enddo
  445 print*,'YES!'
      ENDFILE 33
      close(UNIT=33)
C hmF2
C EOF before to-day:
	OPEN(33,file=OUTFILEH)
	icount=0
	m_strings=0
 1201	read(33,198,end=1204) txt
	CYR=txt(1:2)
	CMN=txt(3:4)
	CDY=txt(5:6)
	if ((cyr.eq.ayr).and.(cmn.eq.amn).and.(cdy.eq.dy1)) then
 	goto 1204
	                  else
         icount=icount+1
      GOTO 1201
      CONTINUE
                  	endif
 1204 m_strings = icount
	REWIND (33)
      icount=0
C
      do while (icount.lt.m_strings)
         READ(33, 198, END=1203) txt
         icount=icount+1
      enddo
 1203 print*,'YES!'
      ENDFILE 33
      close(UNIT=33)
C
C
      OPEN(11,FILE=outfilef,access='APPEND')
	OPEN(12,FILE=outfilem,access='APPEND')
	OPEN(13,FILE=outfileh,access='APPEND')

  331	format(A4,1X,A2,3(1X,I2),1X,F4.1)
C  332	format(A4,1X,A2,3(1X,I2),6X,F4.1)
  332	format(A4,1X,A2,3(1X,I2),6X,F5.2)
  336	format(A4,1X,A2,3(1X,I2),6X,F6.2)
  337	format(3A2,2X,24(I3,A2))
C
	do i=0,23
	jf2(i)=0
	jh2(i)=0
	jm3(i)=0
	enddo

C
	DO 150 idy=idy1,idy2
	 lda=ndoy(jyr,jmn,idy)
	do i=1,4
	do k=0,23
	aff(k,i)=0.0
	amm(k,i)=0.0
	ahm(k,i)=0.0
	enddo
	enddo
	call blet2(idy,ADY)
	infile1(22:23)=ADY
	infile2(22:23)=ADY
	infile3(22:23)=ADY
      OPEN(31,FILE=infile1)
	OPEN(32,FILE=infile2)
	OPEN(34,FILE=infile3)
C
	if (st.eq.'sv') then !========================================================
  151	read(31,337) CYR,CMN,CDY,(jf2(k),CC(k),k=0,23)
      read(31,338) CYR,CMN,CDY,(jm3(k),CC(k),k=0,23)


C
      	IF (st.eq.'mo') THEN				   ! start read-write Mos++++++++++++++++
	infmos(22:23)=ADY
C	      OPEN(33,FILE=infmos,BLANK='ZERO',action='READ')
	      OPEN(33,FILE=infmos,action='READ')
CMoscow 2020 02 13 00:00 foF2	 03.1	 MUF3000F2	 10.4	 hmF2	 282	
C2020-02-05 03:15:00       NaN       NaN       NaN 
C2020-02-05 03:30:00      1.55       NaN      5.18 
C  196 format(A4,1X,A2,3(1X,I2),8X,A5,4X,A6,5X,A5)
C		   mos,CYEAR,cmn,jdy,jut,jum,fof,xfNAN,m3f,xmNAN
  196 format(A6,1X,A4,1X,A2,3(1X,I2),1X,A4,1X,A5,2X,A9,1X,A5,2X,A4,2X
     +,A3)
C  196 format(A62)
  191 format(A49)
	txt='Moscow                 foF2      MUF3000F2  hmF2 ' 
	write(31,191) txt
	write(31,191) txt
	write(31,191) txt
	write(32,191) txt
	write(32,191) txt
	write(32,191) txt
	write(34,191) txt
	write(34,191) txt
	write(34,191) txt
C
  195 xfNAN=' 0.00'
      xmNAN=' 0.00'
	xhNAN='000'
	foF2=0.
	xm3000=0.
      xhmf=0.
      READ(33,196,ADVANCE='YES',EOR=101,END=194) mos,CYEAR,cmn,jdy,jut
     +,jum,fof,xfNAN,m3f,xmNAN
C  195 READ(33,*,END=194) mos,CYEAR,cmn,jdy,jut,jum,fof,xfNAN,m3f,xmNAN
     +,hmf,xhNAN
	goto 102
  101	xhNAN='000'
  102	if (xfNAN.eq.' 00.0') then
	 fof2=0.00
	else
	if (xfNAN(1:1).eq.' ') xfNAN(1:1)='0'
	xfNAN(1:1)='0'
	read(xfNAN,*) fof2
	endif
	if (xmNAN.eq.' 00.0') then
	 xmuf=0.00
	else
	if (xmNAN(1:1).eq.' ') xmNAN(1:1)='0'
	xmNAN(1:1)='0'
	read(xmNAN,*) xmuf
	endif
	if (xhNAN.eq.'   ') then
	 xhmf=0.00
	else
	read(xhNAN,*) xhmf
	endif
	if (fof2.eq.0.) then
	xm3000=0.
	else
	xm3000=xmuf/fof2
	endif
	do kk=1,4
	write(*,331) CYEAR,cmn,jdy,jut,jum,foF2
	write(31,331) CYEAR,cmn,jdy,jut,jum,foF2
	write(*,332) CYEAR,cmn,jdy,jut,jum,xm3000
	write(32,332) CYEAR,cmn,jdy,jut,jum,xm3000
	write(*,336) CYEAR,cmn,jdy,jut,jum,xhmf
	write(34,336) CYEAR,cmn,jdy,jut,jum,xhmf
	if (kk.eq.1) then
	foF2=0.0
	xm3000=0.
	xhmf=0.
	endif
	enddo
	GOTO 195
194	close(unit=33)
	 close(unit=31)
	close(unit=32)
	close(unit=34)
      OPEN(31,FILE=infile1)
	OPEN(32,FILE=infile2)
	OPEN(34,FILE=infile3)
	                  ENDIF  ! end read-write mos  ++++++++++++++++++++++++++++++++++
C
   55 READ(31, 198, END=155) txt ! extra line
	READ(31, 198, END=155) txt ! extra line
	READ(31, 198, END=155) txt ! extra line
	READ(32, 198, END=155) txt ! extra line
	READ(32, 198, END=155) txt ! extra line
	READ(32, 198, END=155) txt ! extra line
	if (st.ne.'mo') goto 155
	READ(34, 198, END=155) txt ! extra line
	READ(34, 198, END=155) txt ! extra line
	READ(34, 198, END=155) txt ! extra line
C
  155    do 1111 iut=0,23 	            !+++++++++++++++++
C
	do jj=1,4
      READ(31, 331, END=157) CYEAR,cmn,jdy,jut,jum,Aff(iut,jj)
	enddo
C
  157	do jj=1,4
      READ(32, 332, END=158) CYEAR,cmn,jdy,jut,jum,Amm(iut,jj)
	enddo
C
       if (st.ne.'mo') then 
	do jj=1,4
      Ahm(iut,jj)=0.
	enddo
	 goto 1111
	endif
C
 1157	do jj=1,4
      READ(34, 336, END=158) CYEAR,cmn,jdy,jut,jum,Ahm(iut,jj)
	enddo
 1111	CONTINUE	 ! end iut

  158	DO iut=0,23
      if (aff(iut,1).gt.0.) then   !1
	af2=aff(iut,1)
      goto 159
      	else
C 
      if (iut.gt.0) then			   !2
	af2=amax1(aff(iut-1,4),aff(iut-1,3))
C
	if (af2.gt.0.) then				 !3
      goto 159
	               else				  !3
	af2=amax1(aff(iut,2),aff(iut,3))
      goto 159
	endif							  !3
	endif							  !2
	endif                             !1
C
  159    if (amm(iut,1).gt.0.) then	  !1m
	am3=amm(iut,1)
      goto 1159
      	else
C 
      if (iut.gt.0) then				   !2m
	am3=amax1(amm(iut-1,4),amm(iut-1,3))
C
	if (am3.gt.0.) then				 !3m
      goto 1159
	               else				 !3m
	am3=amax1(amm(iut,2),amm(iut,3))
      goto 1159
	endif	                          !3m
	endif							   !2m
	endif                             ! 1m
C
 1159 if (st.ne.'mo') goto 1177
C
      if (ahm(iut,1).gt.0.) then	  !1m
	ah2=ahm(iut,1)
      goto 1156
      	else
C 
      if (iut.gt.0) then				   !2m
	ah2=amax1(ahm(iut-1,4),ahm(iut-1,3))
C
	if (ah2.gt.0.) then				 !3m
      goto 1156
	               else				 !3m
	ah2=amax1(ahm(iut,2),ahm(iut,3))
      goto 1156
	endif	                          !3m
	endif							   !2m
	endif                             ! 1m
C
C Add calculation hmF2 from foF2,M3F2 (all stations but mos)
C
 1177 CONTINUE
	UT=float(iut)
	if (st.eq.'at') then
	glat=at%glat
	glon=at%glon
	endif 
c-	if (st.eq.'wz') then
c-	glat=wz%glat
c-	glon=wz%glon
c-	endif 
	if (st.eq.'so') then
	glat=so%glat
	glon=so%glon
	endif 
	if (st.eq.'sv') then
	glat=sv%glat
	glon=sv%glon
	endif 
C
	call subxhi(glat,glon,lda,ut,xhi,xhinon)
	abslat=abs(glat)
      FOE=FOEEDI(COV,XHI,XHINON,ABSLAT)
C-	fm=af2
	ah2=0.0
C-	ires(iut)=0
	if ((af2.gt.0.).and.(am3.gt.0.)) then
	       ah2=peakh(foE,af2,am3)
	if ((ah2.gt.450.).or.(ah2.lt.160.)) ah2=0.0
	endif
C-	hmf2(iut)=hmut
C-	ires(iut)=nint(hmut)

 1156	jf2(iut)=nint(af2*10.)
      jh2(iut)=nint(ah2)
	jm3(iut)=nint(am3*100.)
      enddo
	write(*,334) ayr,amn,ady,(jf2(k),k=0,23)
	write(11,334) ayr,amn,ady,(jf2(k),k=0,23)
	write(*,334) ayr,amn,ady,(jm3(k),k=0,23)
	write(12,334) ayr,amn,ady,(jm3(k),k=0,23)
	write(*,334) ayr,amn,ady,(jh2(k),k=0,23)
	write(13,334) ayr,amn,ady,(jh2(k),k=0,23)
C Add for Ebro:
C+	call subsao6c('eb',ayr,amn,ady)
C
	do i=0,23
	jf2(i)=0
	jm3(i)=0
	jh2(i)=0
	enddo
  150	continue
  444 print*,'YES!'
      close(UNIT=31)
	      close(UNIT=32)
	close(unit=34)
	close(unit=11)
	close(unit=12)
	close(unit=13)
CCC
C  333 CONTINUE
  333     call subcbkf1n(AYR,AMN,DY1,DY2,st)
CCC
  334	format(3A2,2X,24(I3,2X))
  335	format(2A2,I2,2X,24A5)
  152	pause ' '
      STOP
	END
C ===============================================================
