	program histwsub
C .......................................................Aug. 2015
C Percentage occurrence of Substorms in Arctic and Antarctic per month
c for 1999-2015/06.......................................................
C
c
	DIMENSION IM(12),icntmn(12),sw(31,0:23,4) ! B, Bz, PD, SW
	+,avsw(12),icntw(12)
	CHARACTER*64,infile,outfile,outyr,infilesw,txt
	CHARACTER*2 AYR,AMN
	CHARACTER*4 AYEAR
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
   31 format(A64)
   33 format(1X,3I2,1X,I2,13X,F4.0)
C
	outfile='histwsub.txt'  ! 
      OPEN(12,FILE=OUTFILE,ACCESS='APPEND')
	outyr='histwsubyr.txt'
      OPEN(13,FILE=OUTYR,ACCESS='APPEND')

	infilesw='d:\Apkp\OMNI\swYEARMN.txt'
	iflag=0
	infile='catqun.txt'  ! Actic W+
   99	iflag=iflag+1
      if (iflag.eq.5) goto 802
	if (iflag.eq.1) infile(5:6)='un'
	if (iflag.eq.2) infile(5:6)='ln'
	if (iflag.eq.3) infile(5:6)='us'
	if (iflag.eq.4) infile(5:6)='ls'
	write(*,*) infile
	write(12,*) infile
	write(13,*) infile
C
	OPEN(11,FILE=INFILE,action='READ')
C
	iyyyy=1998
C start cycle on Year
 100	iyyyy=iyyyy+1
C
	if (iyyyy.gt.2015) goto 801 ! total result =>
	icyr=0
	icwyr=0
	year=float(iyyyy)
	if(int(year/4.)*4.eq.iyyyy) THEN 
	ndnr=366
	im(2)=29
	                          ELSE
	ndnr=365
	im(2)=28
	if (iyyyy.eq.2015) ndnr=212   ! June 2015 included
	ENDIF
C
	call blet4(iyyyy,AYEAR)
	infilesw(16:19)=AYEAR
C
	AYR=ayear(3:4)
	iyr=iyyyy-(iyyyy/100)*100
C
C
200   continue	  !
C
	do kk=1,12
	icntmn(kk)=0
	avsw(kk)=0.
	icntw(kk)=0
	enddo
C start  mn-to-mn cycle >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C-      DO 1234	imn=1,imnend
C		
c-	call blet2(imn,AMN)

C
c 990113 12  990113  19  44.2  990114  4   17   26.7    1     
C  Input datafile 
C
	jmn_pre=0
   36	FORMAT(2X,I2,1X,I3,1X,I2,3(1X,F5.1),1X,F5.0)
    1	READ (11,32,END=22,ERR=2) jyr1,jmn1,jdy1,jut1,jyr2,jmn2,jdy2,jut2
     +,ihdur !duration hours
  32	FORMAT(1X,3(I2),1X,I2,2X,3I2,2X,I2,18X,I4)
	if (jyr1.eq.iyr) then

C Read SW file for the month:
	if (jmn1.gt.jmn_pre) then
	jmn_pre=jmn1
	call blet2(jmn1,AMN)
	infilesw(20:21)=AMN
	OPEN(10,file=infilesw,action='READ')
	do k=1,12
	read(10,31) txt ! extra lines
	enddo
	do idd=1,im(jmn1)
	do ihr=0,23
	read(10,36,end=37) kyr,kdoy,kut,(sw(idd,ihr,k),k=1,4)
	enddo
	enddo
   37	close(unit=10)
	endif
C
c-	lda1=ndoy(jyr1,jmn1,jdy1)
c-	lda2=ndoy(jyr2,jmn2,jdy2)
C
C If Bz <0
	if ((sw(jdy1,jut1,2).lt.0.).or.(sw(jdy2,jut2,2).lt.0.)) then
	        if (sw(jdy1,jut1,4).lt.9999.0) then  ! avoid missed SW speed
	icntmn(jmn1)=icntmn(jmn1)+ihdur	 ! substorms hours duration
	icntw(jmn1)=icntw(jmn1)+1        ! substorms events count
	avsw(jmn1)=avsw(jmn1)+sw(jdy1,jut1,4)
	          endif
	endif
	goto 1
	               else
	backspace(11)
	endif
C

CREM  55   CLOSE(unit=11)
C
   22 do kk=1,12
      icyr=icyr+icntmn(kk)
	icwyr=icwyr+icntw(kk)
	hrsmn=24.*im(kk)
	prmn=icntmn(kk)/hrsmn*100. 
	aversw=0.
	if (icntw(kk).gt.0.) aversw=avsw(kk)/icntw(kk)
	call blet2(kk,AMN)
	write(*,34) AYEAR,AMN,prmn,aversw,icntw(kk)
      write(12,34) AYEAR,AMN,prmn,aversw,icntw(kk)
	enddo

  	CONTINUE ! End of monthly 
	hrsyr=ndnr*24.
	pryr=icyr/hrsyr*100.
	write(*,35) AYEAR,pryr,icwyr
      write(13,35) AYEAR,pryr,icwyr

   34 format(1X,A4,A2,1X,F5.2,1X,F7.1,1X,I4)
   35 format(1X,A4,1X,F5.2,1X,I4)
C 
	goto 100           !  GO TO NEXT YEAR

  801	CLOSE(unit=11)
	goto 99

  802 CLOSE(unit=12)
	CLOSE(unit=13)
	
      goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

