      subroutine subcbkf1n(AYR,AMN,ADY1,DY2,stname)
C..............................................................July 2019
C
C..............................................................Sep. 2017
C Option for one given station
C
C add cycle on Eur & Aus stations to interpolate foF2 from CBK European & Australian f-maps
C EUM: lats 35:1:70; longs -10:2:90 
c AUM	 lats -80:2:0, longs 110:2:180
C	   
      DIMENSION IM(12),iff2(2,0:23),ifres(0:23)
	+,glats(43),glons(43)
	CHARACTER*128 OUTFILEF,ctext,text(366)
	CHARACTER*1 C1F(2,0:23),C2F(2,0:23)
	CHARACTER*2 stcode,ayr,amn,aut,cyr,cmn,cdy,ady1
	+,DY2,stname,ST(43)
	CHARACTER*6	YMD(2)
	CHARACTER*4	YEAR
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA ST/
     + 'at','an','ch','db','ea','eb','ff','gm','is','jr'
     +,'kg','mo','nc','pq','ro','rv','vt','wz','tr','mm'
     +,'tk','sd','tz','ns','so','go','ad','sv','no','tq'
     +,'br','cb','cn','cw','cr','dw','ho','lm','mq','nd'
     +,'pe','sq','tv'/
	DATA glats/
	+ 38.4,39.9,51.6,50.1,37.1,40.8,51.7,37.6,41.1,54.6
	+,54.7,55.5,35.0,50.0,41.8,47.2,40.6,52.2,69.7,68.0
     +,56.5,66.5,61.6,54.6,67.4,60.3,37.9,56.4,69.4,69.6
     +,-27.5,-35.3,-34.0,-66.3,-43.6,-12.2,-42.9,-21.8,-54.5,-29.0
     +,-32.0,-77.9,-19.7 /
	DATA glons/23.6,32.8,-1.3, 4.6,-6.7, 0.5,-1.8,14.0,29.0,13.4
	+,20.6,37.3,33.2,14.6,12.5,39.7,16.7,21.1,19.0,33.0
     +,84.9,66.5,90.0,83.2,26.6,29.4,58.3,58.6,88.1,41.3
     +,152.9,149.1,150.7,110.5,172.8,130.9,147.2,114.1,159.0,168.0
     +,115.9,166.8,146.9/
C Test
	year='2019'  ! TEMP
	year(3:4)=AYR
C	ayr=year(3:4)
	outfilef='d:\web\graf\2020\styrf.br'
   15	FORMAT(A4)
	outfilef(15:16)=ayr
	outfilef(20:21)=ayr

  200 continue
  198	format(1X,A2)
  199	format(A2)
	do 300 jsta=1,43
	stcode=st(jsta)
	if (stcode.ne.stname) goto 300
      glat=glats(jsta)
      glon=glons(jsta)
	ieof=0
	write(*,198) stcode
	 OUTFILEF(18:19)=stcode
C
  201	continue
      	read(ayr,*) yr
       iyr=int(yr)
	read(amn,*) rmn
      mn=int(rmn)
      read(ady1,*) rdy1
	idy1=int(rdy1)
      read(DY2,*) rdy2
	idy2=int(rdy2)
	lda_pre=ndoy(iyr,mn,idy1)
C//	lda=lda_pre+1
	lda=ndoy(iyr,mn,idy2)
	z1=yr/4.
	jz=int(z1)*4
	IF(jz.EQ.iyr) THEN
               IM(2)=29
					dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF

  220 L=0   
      JFL=0 
  158	format(3A2,2X,24(I3,2A1))
  159	format(A6,2X,24(I3,2A1))
  160	format(A128)
  162	format(A6,24(1X,I4))

	ndnr=im(mn)
C++
C
      	OPEN(12,FILE=OUTFILEF) !
	do 80 i=1,366
      nn=i															   !NEW+6
	read(12,160,end=81) ctext
	text(i)=ctext
	cyr=ctext(1:2)
 	cmn=ctext(3:4)
	cdy=ctext(5:6)
	if ((CYR.eq.AYR).and.(CMN.eq.AMN).and.(CDY.eq.ADY1)) then		   !NEW+6
	backspace(12)
	exit
	endif
   80	continue
C 
C Add reading 2 last days:
   81	do 82 lday=lda_pre,lda
	kk=lday-lda_pre+1
	do k=0,23
	iff2(kk,k)=0
      C1F(kk,k)=' '
	C2F(kk,k)=' '
	enddo
	read(12,159,end=82) YMD(kk),(iff2(kk,k),C1F(kk,k),C2F(kk,k)
	+,k=0,23)
C
   82 CONTINUE
   84 close(unit=12)
C Re-write outfile for prec. period:
	OPEN(12,file=OUTFILEF)
	do i=1,nn-1
	write(12,160) text(i)                                                 
	enddo
C
	ctext=text(nn) ! 
	close(unit=12)
	OPEN(12,FILE=OUTFILEF,access='APPEND')				  ! file foF2.br
C++
C Day-to-day cycle:
	idys=0
	DO 260 lday=lda_pre,lda
	kk=lday-lda_pre+1
	call submmdd(lday,iyr,imn,idy)
      call blet2(iyr,CYR)
	call blet2(imn,CMN)
		call blet2(idy,CDY)
C++++++++++++++++++++++++++++++++++++++
      DO iut=0,23
	call blet2(iut,AUT)
	IF ((iff2(kk,iut).eq.0.).or.(C1F(kk,iut).eq.'/')) THEN
C
	if (glat.gt.0.) then
	call subintereu(glat,glon,cyr,cmn,cdy,aut,diasf)
	else
      call subinterau(glat,glon,cyr,cmn,cdy,aut,diasf)
	endif
C
	if (diasf.gt.0.) then
	iff2(kk,iut)=nint(diasf*10.)
      C1F(kk,iut)='_'
	                 else
		iff2(kk,iut)=0
	C1F(kk,iut)='/'
	endif
	ENDIF
	ifres(iut)=iff2(kk,iut)
c	if ((ifres(iut).eq.34).and.(C1F(kk,iut).eq.'_')) then
c	ifres(iut)=0
c	C1F(kk,iut)='/'
c	endif
C+
	ENDDO	
	write(*,158) CYR,CMN,CDY,(ifres(k),C1F(kk,k),C2F(kk,k),k=0,23)
	write(12,158) CYR,CMN,CDY,(ifres(k),C1F(kk,k),C2F(kk,k),k=0,23)
C++++++++++++++++++++++++++++++++++++++
  260	continue ! end day-to-day cycle
C
  301	close(unit=12)
  300	CONTINUE ! end stations cycle
      RETURN
	pause ' '
c//      STOP
	end