C ///////////////////////////////////////////////////////////////      
	 SUBROUTINE SUBDEVFOF2(ST)
C...........................................................Dec 2022
C
C...........................................................May 2021
C
C ..........................................................Nov 2019
C Enter station site <ST> as formal parameter
C
C Move median calculation into separate subroutine SUBMED27.for -27 prec. days...............
C
C
C T.L.Gulyaeva .................................................

C WNmF2 index using foF2med from -27 prec. days
C Include logarithmic scale indices -4,-3,-2,-1,0,1,2,3
C
      DIMENSION IM(12),DX(0:23),DA(28,0:23),DEV(0:23),XMED(0:23)
     +,IWTEC(0:23),CC(27,0:23),IDEV(0:23),IMED(0:23)
	CHARACTER*128 INFILE,OUTFILE1,OUTFILE2,OUTFILE3,TXT31(31)
C      CHARACTER*41 ile1, ole1
	CHARACTER*4 AYEAR,CYEAR,CTIME
	CHARACTER*2 AYR,AMN,ADY,DY1,DY2,CMN,CDY,ST,AMN_pre,AMN_cur
	CHARACTER(8) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*56 txt3,txt4,txt6
	CHARACTER*16 txt2,txt5
	CHARACTER*12 txt1w,txt1m,txt1d
	CHARACTER*13 STAT
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	COMMON /BL1/CC,XMED
      COMMON /BL2/STAT,AYEAR,AMN_pre,AMN_cur,DY1,DY2,GLATK,GLONK
	
C
C    Start:
C
	txt1w='WfoF2-index '
	txt1m='foF2med*10  '
	txt1d='log(Ne/NmF2)'
      txt2='Date of issue:  '
      txt3='YYMMDD|UT 0    1    2    3    4    5    6    7    8    9'
	txt4='   10   11   12   13   14   15   16   17   18   19   20 '
	txt5='  21   22   23  '  
      txt6='--------------------------------------------------------'
	      CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
	CYEAR=DD(1:4)
	CMN=DD(5:6)
	CDY=DD(7:8)
	CTIME=tt(1:4)
	AYR=AYEAR(3:4)
C
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
C
	read(AMN_cur,*) rmn
	IMN=int(rmn)   ! current mn
	read(AMN_pre,*) rmn_pre
	IMN_pre=int(rmn_pre)   ! current mn
C
	if (iyr.lt.90) then
	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C
C
	read(DY1,*) rdy1
	idy1=int(rdy1)
	read(DY2,*) rdy2
	idy2=int(rdy2)
C
C Start for station:
	write(*,*) st,AYR,AMN,DY1,DY2          ! ++
200	CONTINUE
C Start from DY1 to DY2
 
Cpre      infile1='d:\web\graf\dat1\YR\stYRMN.txt'	 ! prec. month  Tamara
      infile='d:/web/graf/temp/stYRf.br'	 !   Tamara

C++      infile='/var/www/izmiran/ionosphere/weather/graf/'   !!!!! LIUBA 41

C++      ile1='dat1/YR/stYRMN.txt'   !!!!!  LIUBA_pre
C++      ile1='temp/stYRf.txt'   !!!!!  LIUBA_new!!!!!!!!!!!!

	INFILE(18:19)=st							 ! Tamara
	INFILE(20:21)=ayr							 ! Tamara

C++	ile1(6:7)=st							 ! LIUBA  ??????
C++	ile1(8:9)=cyr							 ! LIUBA  ??????

C++	infile(42:)=ile1						 ! LIUBA  ??????

      WRITE(*,*) 'infile = ',infile
C
C
C  =======================================================================
C
	      DO I=1,28
                   DO K=0,23
	      DA(I,K)=0.
	 enddo
	      ENDDO
C
  700 format(A128)
   12	FORMAT(3I2,2X,24(F3.1,2X))
      ncnt=0        ! count of days 1,2,...,27   
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Cycle on DY1 & DY2
C
       DO 1100 kdd=1,2
	if (kdd.eq.1) then
	AMN=AMN_pre
	ADY=DY1
	kdy=idy1
	               else
	AMN=AMN_cur
	ADY=DY2
	kdy=idy2
	              endif
C
      outfile1='d:\web\graf\dat2\YR\stYRMNm.txt'	 ! cur. month Tamara

C++      outfile1='/var/www/izmiran/ionosphere/weather/graf/'  ! cur. month ! LIUBA

C++      ole1='dat2/YR/stYRMNm.txt'				   ! LIUBA

C++      outfile1(42:)=ole1					   ! LIUBA

      OUTFILE1(21:22)=st							 ! Tamara
	outfile1(18:19)=AYR							 ! Tamara
	outfile1(23:24)=AYR							 ! Tamara
	outfile1(25:26)=AMN 						 ! Tamara

C++      OUTFILE1(50:51)=st							 ! LIUBA
C++	outfile1(47:48)=AYR							 ! LIUBA
C++	outfile1(52:53)=AYR							 ! LIUBA
C++	outfile1(54:55)=AMN							 ! LIUBA

      WRITE(*,*) 'outfile1 = ',outfile1

	outfile2=outfile1  							 ! Tamara
	outfile2(16:16)='3'							 ! Tamara
	outfile2(27:27)='d'							 ! Tamara

C++	outfile2(45:45)='3'							 ! LIUBA
C++	outfile2(56:56)='d'							 ! LIUBA

	     WRITE(*,*) 'outfile2 = ',outfile2

	outfile3=outfile1  							 ! Tamara

	outfile3(16:16)='4'							 ! Tamara
	outfile3(27:27)='i'							 ! Tamara

C++	outfile3(45:45)='4'							 ! LIUBA
C++	outfile3(56:56)='i'							 ! LIUBA

	     WRITE(*,*) 'outfile3 = ',outfile3

C+++
C==      if (idy1.ge.27) goto 230	  ! goto input of current month

C  input of data up to current day
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C==	nndy=im(jmn_pre)	  ! prec. mn
C==	nnd1=nndy-25
C
      OPEN(12,FILE=INFILE,action='READ')
C
C  day-to-day input for prec mon
C
C==	DO 400 jdy_pre=nnd1,nndy  ! for all UT

C Reading foF2 data from statyrmnt.txt file:
  59   READ (12,12,END=105,ERR=2) jYR,jMN,jDY,(DX(k),k=0,23)
        DO k=0,23
	da(28,k)=DX(k)
	  enddo
	if ((jyr.eq.iyr).and.(jmn.eq.imn).and.(jdy.eq.idy2)) then	 !Dec 2022
	GOTO 400
	                                                    ELSE
C Move data day-by-day up so that last day of month nndy=>day_27:
	do j=2,28			  ! <day-by-day
	do k=0,23			  ! all UT
	da(j-1,k)=da(j,k) ! move data one day up  
	enddo				  ! all UT
	enddo				  ! all days
	endif						                                 ! DEC 2022
C
	goto 59																  !May 2021
C-	                 endif												  !May 2021
C
  400	CONTINUE		  !<day-by-day
  105	close(unit=12)
      ncnt=27                             ! Dec 2022
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
  230	continue
      OPEN(13,FILE=OUTFILE1)  !dat2/fmed		 !May 2021
	OPEN(14,FILE=OUTFILE2)	!dat3/Dlog			 !May 2021
	OPEN(15,FILE=OUTFILE3)	!dat4/W-index		 !May 2021
		if (kdy.eq.1) then
 	write(*,32) stat,st,txt1m,glatk,glonk	! f-median
	write(13,32) stat,st,txt1m,glatk,glonk
	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(13,18) cyear,cmn,cdy,ctime
		write(*,201) 
		write(13,201) 
 	write(*,32) stat,st,txt1d,glatk,glonk  ! DEVlog
	write(14,32) stat,st,txt1d,glatk,glonk
	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(14,18) cyear,cmn,cdy,ctime
		write(*,201) 
		write(14,201) 
 	write(*,32) stat,st,txt1w,glatk,glonk  ! W-index
	write(15,32) stat,st,txt1w,glatk,glonk
	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(15,18) cyear,cmn,cdy,ctime
		write(*,201) 
		write(15,201) 
           GOTO 115 ! Avoid READ PREC data
	endif
C read data up to day-1
	DO mdy=1,kdy+3
	read(13,700,end=111) txt31(mdy)
	ENDDO
  111	close(13)
      OPEN(13,FILE=OUTFILE1)  !dat2/fmed
	DO mdy=1,kdy+3
	if (mdy.eq.2) then
	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(13,18) cyear,cmn,cdy,ctime
         else
	write(13,700) txt31(mdy)
	endif
	ENDDO
C
C read data up to day-1
	DO mdy=1,kdy+3
	read(14,700,end=112) txt31(mdy)
	ENDDO
  112	close(14)
      OPEN(14,FILE=OUTFILE2)  !dat2/fmed
	DO mdy=1,kdy+3
	if (mdy.eq.2) then
	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(14,18) cyear,cmn,cdy,ctime
         else
	write(14,700) txt31(mdy)
	endif
	ENDDO
C
C read data up to day-1
	DO mdy=1,kdy+3
	read(15,700,end=113) txt31(mdy)
	ENDDO
  113	close(15)
      OPEN(15,FILE=OUTFILE3)  !dat2/fmed
	DO mdy=1,kdy+3
	if (mdy.eq.2) then
	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(15,18) cyear,cmn,cdy,ctime
         else
	write(15,700) txt31(mdy)
	endif
	ENDDO
C

32	format(A13,1X,A2,1X,A12,2X,'glat ='F5.1,1X,'glon ='F5.1)    !txt1='WTEC-index'
   18	format('Date of issue: ',A4,'/',A2,'/',A2,' Time:',A4)
  201	format('YYMMDD|UT 0    1    2    3    4    5    6    7    8'
     &'    9   10   11   12   13   14   15   16   17   18   19   20'
     &'   21   22   23'/'-------------------------------------------'
     &'-------------------------------------------------------------'
     &'------------------------')
c
  115	do k=0,23
	iwtec(k)=0
	xmed(k)=0.
	dev(k)=0.
	enddo

C $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C 
  10	CONTINUE
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  CALCULATION OF MEDIAN
C  115   for -27 prec days median
      DO J=1,27
        DO M=0,23          ! Hour-to-hour cycle: variable <m>
	if (kdd.eq.1) then
        CC(J,M)=DA(j,M)
	else
	  CC(J,M)=DA(j+1,M)
	endif
	ENDDO
	ENDDO
	CALL RMEDIAN27(27)
C
C WTEC index:
C
          DO M=0,23
      XMD=XMED(M)**2	       !NmF2 = foF2**2
	xpar=CC(27,M)**2	    !NmF2 = foF2**2
	devlog=0.
	call windex(xpar,xmd,devlog,iw)
	DEV(M)=devlog
	IWTEC(M)=iw
	IDEV(m)=nint(devlog*1000.)
	if (idev(m).lt.-999) idev(m)=-999			   ! May 2021
	if (idev(m).gt.9999) idev(m)=9999			    ! May 2021
	IMED(m)=nint(xmed(m)*10.)
	     ENDDO
C
	WRITE(*,158) ayr,amn,ady
     *,(IMED(K),K=0,23)
	WRITE(13,158) ayr,amn,ady
     *,(IMED(K),K=0,23)
	WRITE(*,158) ayr,amn,ady
     *,(IDEV(K),K=0,23)
	WRITE(14,158) ayr,amn,ady
     *,(IDEV(K),K=0,23)
	WRITE(*,158) ayr,amn,ady
     *,(IWTEC(K),K=0,23)
	WRITE(15,158) ayr,amn,ady
     *,(IWTEC(K),K=0,23)
 158  FORMAT(3A2,24(1X,I4))
C
       close(unit=13)
      close(unit=14)
	close(unit=15)
C-----------------------------------
1100	CONTINUE	   ! end cycle DY1 & DY2
C
C==	 ncnt=26
      goto 108		  ! to the return
C
c
    2 CONTINUE
	       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
		   	pause ' '   !Tamara
C	   	pause ' '   !!! Liuba
      close(unit=12)
C	
  108 RETURN              
	END
