      subroutine subinterpco(fhdat,glat,glon,res)
C.................................................................Oct. 2018
C Gulyaeva Tamara <gulyaeva@izmiran.ru>
C
C Subroutine to interpolate data from IONEX maps of center-of-mass
C Input : infilef = input file
C         ymlat - geomagnetic latitute
C         ymlon - geomagnetic longitude
C.................................................................
C Outpur : res - value of co (km)
C 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C co interpolated from directory dhc maps - update addresses for input file
C
	DIMENSION fhdat(0:72,71)	  ! maps co
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C      interpolate for glat,glon
C Linear Interpolation   
	amlat=-90.
	res=0.
	res11=0.
	res12=0.
	res21=0.
	res22=0.
	do 161 ilat=1,71 ! select pair of lats-lines (k) & (k+1)
c	mlat=-87.5,-85,...,87.5
	amlat=-90.+2.5*ilat
	amlat2=amlat+2.5
	if (amlat.eq.87.5) amlat2=amlat
C
	if ((glat.ge.amlat).and.(glat.le.amlat2)) then  !   <<<<1
C Select pair of longs embracing glong
	 clon=-5.
	along=glon
	do j=0,71 ! select pair of longs (j) & (j+1)
	clon=clon+5.
	clon2=clon+5.
	if ((along.ge.clon).and.(along.lt.clon2)) then  ! +++2
	res11=fhdat(j,ilat)
	res12=fhdat(j+1,ilat)
	res21=fhdat(j,ilat+1)
	res22=fhdat(j+1,ilat+1)
	res1=res11+(res12-res11)/5.*(along-clon)
	res2=res21+(res22-res21)/5.*(along-clon)
	res=res1+(res2-res1)/2.5*(glat-amlat)
	endif											 ! +++2
	enddo	! end select pair of longs (j) & (j+1)
	exit
	endif											 !   <<<<1
  161 continue		   ! interpolation end
	RETURN
	END