      subroutine subm3000(foE,foF2,hmf2,xm3)
C-      real MF,M3000
C-      sqM=M3000*M3000
C-      MF=M3000*sqrt((0.0196*sqM+1.)/(1.2967*sqM-1.0))
         if (hmF2.eq.0.) then
	xm3=0.0
	return
	  endif
      If(foE.ge.1.0E-30) then
         ratio=foF2/foE
         ratio=djoin(ratio,1.75,20.0,ratio-1.75)
         dM=0.253/(ratio-1.215)-0.012
      else
         dM=-0.012
      endif
      xm3=1490.0/(hmf2+176.0)-dM
      return
      end
C-----------------------------------------------------------------
	      real function djoin(f1,f2,alpha,x)
      real f1,f2,alpha,x,ee,fexp
      ee=fexp(alpha*x)
      djoin=(f1*ee+f2)/(ee+1.0)
      return
      end
C-----------------------------------------------------------------
       real function fexp(a)
      real a
      if(a.gt.80.0) then
         fexp=5.5406E34
         return
      endif
      if(a.lt.-80.0D0) then
         fexp=1.8049E-35
         return
      endif
      fexp=exp(a)
      return
      end
C-----------------------------------------------------------------
