	program cntocwj1
C.....................................................Apr. 2013
C Cnt Occ. (grid number) with (1) W==3,+4, (2) W=-3, -4
C select peak Occ. for the day 1999-2012
C.....................................................Mar. 2013
C Count histogram of occurremce of W=-4,-3,-2,-1,0,1,2,3,4
C                               ihist 1  2  3  4 5 6 7 8 9
C  
C
C JPL maps
C.....................................................Apr. 2012
C
C IONEX maps
C for glat=-87.5:2.5:87.5, glong=-180:5:165  (5112 => 840 grids)
C Correction of (W+max-W-max)*(1+cntstrm/5112)
C
c from hourly IONEX maps
c
	DIMENSION IDHR(0:71),IM(12)
	+,histp(12),histn(12)  ! hist(mn) Occ.% of W+,W- storm mn=1,...,12; 
	 INTEGER*2 IYR,IMN,IDY,idy1,idy2,iut,kyr,iyr0
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64,infile,outfile,outfilep,outfilen
	CHARACTER*2 AYR,AMN,AUT,ADY
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
c=	DATA IWP/-4,-3,-2,-1,0,1,2,3,4/
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

C start
      outfile='cntocwYR.txt'	! daily peak Occ. W+- from W-maps geogr.coord.
	outfilep='cntocwjp'		 !monthly W+
	outfilen='cntocwjn'		 !monthly W-
  	OPEN(112,FILE=OUTFILEP,access='APPEND')
	OPEN(113,FILE=OUTFILEN,access='APPEND')

C
C start cycle on year: =====================================
C
crem	iyear0=1998
crem	iyr0=98
	iyr=8
C
crem	DO 400 kyr=1,14
crem	iyr=iyr0+kyr
crem	if (iyr.ge.100) iyr=iyr-100
	call blet2(iyr,AYR)
	outfile(7:8)=AYR
	OPEN(114,FILE=OUTFILE,access='APPEND')

	xmap=5112.
	year=float(iyr)
	if(int(year/4.)*4.eq.iyr) THEN 
	ndnr=366
	im(2)=29
	cntwyr=xmap*24*366.  
	                          ELSE
	ndnr=365
	im(2)=28
	cntwyr=xmap*24*365.  
	ENDIF
	cntot=cntot+cntwyr
	cntmonp=0.
	cntmonn=0.
	do k=1,12
	histp(k)=0  ! Monthly count of daily peak Occ.W+
	histn(k)=0	 ! Monthly count of daily peak Occ.W-
	enddo

C start cycle on month ---------------------------------
	DO 401 imn=1,12
	call blet2(imn,AMN)
      
 13   FORMAT(I2)
crem	idy1=1
crem	idy2=im(imn)
	idy1=5
		idy2=7
CC CALCULATION OF DAYS OF YEAR	
      infile='d:\web\dws\YR\MN\wcMNDYUT.jYR' ! JPL W(glat & glong map)
  	infile(12:13)=ayr
	infile(15:16)=amn
  	infile(28:29)=ayr
	infile(20:21)=amn
C
 198	format(4X,A2,24(3X,A2),3X,A4)
C
	mndy=idy2
C??	cntmon=xmap*24.*float(mndy)
  130	format(A133)

C
C
CC  
  197 continue
C
C  day-to-day cycle
C ========================================

       DO 500 idy=idy1,idy2
	lda=ndoy(iyr,mn,idy)  ! day-of-year
	call blet2(idy,ady)
	infile(22:23)=ady
C
C
C cycle on UT:
	ipeakwp=0   !Daily peak occ.W+=+3 &+4
	ipeakwn=0	!Daily peak occ.W-=-3 &-4
C -----------------------------------------------------
      DO 801 iut=0,23		! cycle on UT
	call blet2(iut,aut)
	infile(24:25)=aut
	OPEN(111,FILE=INFILE)
c
C ===== Input datafile 
	icntp=0    ! UT hourly cnt W=+3 +4
	icntn=0	   ! UT hourly cnt W=-3 -4
 1311	DO 1799 jj=1,71	  ! glats= -87.5:2.5:87.5
c	pause ' '
    1	READ (111,12,END=3,ERR=2) (IDHR(k),k=0,71) ! W(longs=-180:5:175)
  12	FORMAT(72(1X,I4))
C
        DO k=0,71				! Cycle on Longi	 <<<<<<<<
C++ Count histogram indices W:
	  if ((idhr(k).eq.3).or.(idhr(k).eq.4)) then
	   icntp=icntp+1
	endif
	  if ((idhr(k).eq.-3).or.(idhr(k).eq.-4)) then 
	  icntn=icntn+1
	endif
 	  ENDDO		    ! Cycle on Longi	 >>>>>>>>>>>>>

 1799	CONTINUE				   ! Cycle jj on glats (total W map)
  3   CLOSE(unit=111)
C Select daily peak Occ.
crem	if (icntp.gt.ipeakwp) ipeakwp=icntp
crem	if (icntn.gt.ipeakwn) ipeakwn=icntn
	percp=float(icntp)/xmap*100. !Peak daily Occ.*100 W+ %
	percn=float(icntn)/xmap*100. !Peak daily Occ.*100 W- %
	write(*,173) AYR,AMN,ADY,iut,percp,percn       ! daily peak Occ. W+, W-
	write(114,173) AYR,AMN,ADY,iut,percp,percn
C----------------------------------------------------------
  801 continue            ! end cycle on UT 
crem	percp=float(ipeakwp)/xmap*100. !Peak daily Occ.*100 W+ %
crem	percn=float(ipeakwn)/xmap*100. !Peak daily Occ.*100 W- %
crem	write(*,73) AYR,AMN,ADY,percp,percn       ! daily peak Occ. W+, W-
crem	write(114,73) AYR,AMN,ADY,percp,percn
C
	histp(imn)=histp(imn)+percp
	histn(imn)=histn(imn)+percn
  500	CONTINUE ! next day
  73	FORMAT(1X,3A2,2(1X,F7.2))
  173	FORMAT(1X,3A2,1X,I2,2(1X,F7.2))

	histp(imn)=histp(imn)/mndy
	histn(imn)=histn(imn)/mndy

C
  401	CONTINUE ! next month
      CLOSE (UNIT=114) 
C
	write(*,71) AYR
	write(112,71) AYR
	write(*,72) (histp(k),k=1,12)       ! monthly %
	write(112,72) (histp(k),k=1,12)

	write(113,71) AYR
	write(*,72) (histn(k),k=1,12)       ! monthly %
	write(113,72) (histn(k),k=1,12)
  400	CONTINUE ! next year
	close(unit=112)
	close(unit=113)
   71 format(1X,A2)
   72 format(12(1X,F7.2))
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

