	program histsolw
C .......................................................Aug. 2015
C Percentage occurrence of Sol Wind >700 km/s per month
c for 1999-2015/06.......................................................
C
c
	DIMENSION IM(12)
	CHARACTER*64,infile,outfile,txt,outyr
	CHARACTER*2 AYR,AMN
	CHARACTER*4 AYEAR
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
   31 format(A64)
   33 format(1X,3I2,1X,I2,13X,F4.0)
C
	outfile='histsolw.txt'  ! 
      OPEN(12,FILE=OUTFILE,ACCESS='APPEND')
	iyyyy=1998
	infile='d:\Apkp\OMNI\swYEARMN.txt'
	outyr='histswyr.txt'
      OPEN(13,FILE=OUTYR,ACCESS='APPEND')
C1996   1  0   5.7   4.9   7.0  424.

	cyr=0.
	cyrtot=0.
	cyrmis=0.
C start cycle on Year
 100	iyyyy=iyyyy+1
C
	if (iyyyy.gt.2015) goto 801 ! total result =>

	year=float(iyyyy)
	if(int(year/4.)*4.eq.iyyyy) THEN 
	ndnr=366
	im(2)=29
	                          ELSE
	ndnr=365
	im(2)=28
	ENDIF
C
	call blet4(iyyyy,AYEAR)
	infile(16:19)=AYEAR
C
	AYR=ayear(3:4)
	iyr=iyyyy-(iyyyy/100)*100
C
C
200   continue	  !
	imnend=12
	if (iyyyy.eq.2015) imnend=6 !(20015/06)
C start  mn-to-mn cycle >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      DO 1234	imn=1,imnend
C		
	cntmn=0.
	cmis=0.
	ctot=0.
	call blet2(imn,AMN)

	infile(20:21)=AMN
C
	OPEN(11,FILE=INFILE,action='READ')
c     
C  Input datafile 
	do i=1,12
	read(11,31) txt		! extra lines
	enddo
C
    1	READ (11,32,END=55,ERR=2) jyear,jdoy,jut,b,bz,pd,sw !B, Bz, Pd, SW
  32	FORMAT(I4,1X,I3,1X,I2,3(1X,F5.1),1X,F5.0)
	ctot=ctot+1.0
	if (sw.gt.9990.) then
	cmis=cmis+1.
	goto 1
	endif
C
	if (sw.lt.700.0) GOTO 1  ! 
C
	call submmdd(jdoy,jyr,jmn,jdy)
	call blet2(jmn,AMN)
	cntmn=cntmn+1.0      ! cnt of monthly SW >700 
	GOTO 1
  55   CLOSE(unit=11)
C
	cyr=cyr+cntmn
	cyrtot=cyrtot+ctot
	cyrmis=cyrmis+cmis
	cnt=ctot-cmis
	prmn=0.
	if (cnt.gt.0.) prmn=cntmn/cnt*100. 
	write(*,34) AYEAR,AMN,prmn
      write(12,34) AYEAR,AMN,prmn
1234	CONTINUE ! End of monthly file
	cntxx=cyrtot-cyrmis
	pryr=0.
	if (cntxx.gt.0.) pryr=cyr/cntxx*100.
	write(*,35) AYEAR,pryr
      write(13,35) AYEAR,pryr

   34 format(1X,A4,A2,1X,F5.2)
   35 format(1X,A4,1X,F5.2)
C 
	goto 100           !  GO TO NEXT YEAR


  801	CLOSE(unit=12)
	CLOSE(unit=13)
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

