	program rankwnpj
C.....................................................Nov. 2012
C Ranking wj, nj, pj results from JPL maps
C
C IONEX maps
C for glat=-87.5:2.5:87.5, glong=-180:5:165  (5112 => 840 grids)
C Correction of (W+max-W-max)*(1+cntstrm/5112)
C.....................................................Feb. 2012
C
C.....................................................Aug.2011
C
C Input: maps of W-index: tcMNDYUT.wYR files 
C             for glat=-85:5:85, glong=-180:15:165  (=840 grids)
C Correction of (W+max-W-max)*(1+cntstrm/840)
C
C........................................................Apr.2008
C...... Count RANGE only when W+=>3, and/or W-<=-3 ..............
C
c........................................................Oct.2007
C Correction of (W+max-W-max)*(1+cntstrm/600)
C cntstrm=total number of W+=3,W+=4, W-=-3,W-=-4 for the IONEX-map
C
c .......................................................Sep. 2007
C Range of TEC indices from 35 latitude results TEC.fYR.........
C
c from hourly IONEX maps
c
	DIMENSION IM(12)
	+,DATW(31),DATP(31),DATN(31),X1(31),X2(31)
	 INTEGER*2 IYR,MN,idy1,idy2,imn
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64 infilew,infilep,infilen
	+,outfilew,outfilep,outfilen
	CHARACTER*133 txt
	CHARACTER*2 AYR,AMN,CMN
	CHARACTER*6 YYMMDD,YMD(31),Y1(31),Y2(31),ABC
	CHARACTER*4 AYEAR
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C

	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

C start
      WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
      READ(*,'(A)') AYEAR
crem	AYEAR='1999'
      WRITE(*,'(\A\)') ' ENTER LAST MONTH OF INPUT FILE='
      READ(*,*) IMN
	ayr=ayear(3:4)
	read(ayr,*) year
	iyr=int(year)

crem      WRITE(*,'(\A\)') ' ENTER MONTH OF INPUT FILE='
crem      READ(*,'(A)') AMN
crem	read(amn,*) rmn
crem	mn=int(rmn)
	if(int(year/4.)*4.eq.iyr) THEN 
	ndnr=366
	im(2)=29
	                          ELSE
	ndnr=365
	im(2)=28
	ENDIF

CC CALCULATION OF DAYS OF YEAR	
      infilew='d:\web\datw\wptecYR.txt'	! from W-maps geogr.coord.
	infilew(18:19)=AYR
 	infilep=infilew
	infilen=infilew
	infilep(13:13)='p'
	infilen(13:13)='n'
	outfilew='wjrankYR.txt'
	outfilew(7:8)=AYR
	outfilep=outfilew
	outfilep(1:1)='p' 
	 outfilen=outfilew
	outfilen(1:1)='n' 
   14	format(1X,A133)
C
  130	format(A133)
C
  197 continue
  	OPEN(11,FILE=outfilew)
	OPEN(12,FILE=outfilep)
	OPEN(13,FILE=outfilen)

C
C 
C ========================================
C Cycle on months:
	DO 1130 mn=1,imn
	call blet2(mn,AMN)

  	OPEN(111,FILE=infilew)
	OPEN(112,FILE=infilep)
	OPEN(113,FILE=infilen)
	read(111,14) txt  ! extra line
	read(112,14) txt  ! extra line
	read(113,14) txt  ! extra line

	idy1=1
	idy2=im(mn)
 13   FORMAT(I2)
C
	lda1=ndoy(iyr,mn,idy1)  ! day-of-year
	mndy=im(mn)

c/       DO 500 idy=idy1,idy2
c/	lda=ndoy(iyr,mn,idy)  ! day-of-year
c/	call blet2(idy,ady)
C
C -----------------------------------------------------
  12	FORMAT(A6,123X,F4.1)
C ===== Input datafile 
 	DO jj=1,mndy	  ! 
  131  	READ (111,12,END=31,ERR=2) YYMMDD,ZZZ
	CMN=yymmdd(3:4)
	if (CMN.eq.AMN) then
	YMD(jj)=YYMMDD
	DATW(jj)=ZZZ
	                 else
	goto 131
	endif
	enddo
   31	close(unit=111)
C
   	DO jj=1,mndy	  ! 
  132  	READ (112,12,END=32,ERR=2) YYMMDD,ZZZ
	if (yymmdd(3:4).eq.AMN) then
	DATP(jj)=ZZZ
	                 else
	goto 132
	endif
	enddo
   32	close(unit=112)
C
 	DO jj=1,mndy	  ! 
  133  	READ (113,12,END=33,ERR=2) YYMMDD,ZZZ
	if (yymmdd(3:4).eq.AMN) then
	DATN(jj)=ZZZ
	                 else
	goto 133
	endif
	enddo
   33	close(unit=113)
C
C Ranking Wp
C
	iflag=0
	num=11
  879    DO N=1,mndy
      X1(N)=DATW(N)
	Y1(N)=YMD(N)
      ENDDO 
C
      MM=0
	do n=1,31
	X2(n)=0.
 	Y2(n)='000000'
 	enddo
C
  880 XX=0.

CREM MAX X1(N)
  890 DO N=1,mndy
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ABC=Y1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
  930 DO 960 N=1,mndy
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	Y2(MM)=ABC
	IF (ABC.ne.Y1(N)) Y2(MM)=Y1(N)
	X1(N)=0.
	Y1(N)='000000'
  960 CONTINUE      ! N
  970 IF (MM.lt.mndy) GOTO 880
  980 XMM=FLOAT(MM)

C----------------------------------------------------------
c   
  801 continue            ! 
      iflag=iflag+1
	if (iflag.eq.3) then
		DO N=1,mndy
 	write(*,73) Y2(N),X2(N)*(-1.)
	write(13,73) Y2(N),X2(N)*(-1.)
	enddo
       goto 909 ! end-stop
	endif
  73	format(1X,A6,1X,F4.1)
C
	if (iflag.eq.1) then
	DO N=1,mndy
	write(*,73) Y2(N),X2(N)
	write(11,73) Y2(N),X2(N)
	enddo
	do k=1,mndy
	datw(k)=datp(k)
	enddo
	num=12
	goto 879
	endif
C
	if (iflag.eq.2) then
	DO N=1,mndy
	write(*,73) Y2(N),X2(N)
	write(12,73) Y2(N),X2(N)
	enddo
	do k=1,mndy
	datw(k)=datn(k)*(-1)
	enddo
	num=13
	goto 879
	endif
C
  500	CONTINUE ! next day
C
   72 format(A6,24(1X,F4.1),1X,F6.1)
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  909 continue
 1130	continue  ! cycle mn-to-mn
	CLOSE(unit=11)
	CLOSE(unit=12)
	CLOSE(unit=13)
	pause ' '
      STOP
      END

