      program solphase4a
C........................................................Aug 2015
C
C SolPhase for auroral W-clouds occurrence (monthly hrs,%,)
C Exclude months with SW_hs =0.0 %
C
	dimension RMIN(6),RMAX(6)
	character*64 infile, outfile
	integer*2 iyr,imn
	character*2 AYR,AMN
	character*4 AYEAR
	DATA RMIN/1964.9,1976.5,1986.8,1996.9,2008.9,2019.5/
	DATA RMAX/1957.9,1968.9,1979.9,1989.6,2000.3,2014.3/
 
	infile='histwmnxx.txt'	  ! monthly W auroral s-storms, %
	outfile='solphasw4xx.res'
C
	iflag=0
C
    1	iflag=iflag+1
	if (iflag.eq.5) goto 180 ! STOP
      if (iflag.eq.1) then
	infile(8:9)='un'
	outfile(10:11)='un'
	endif
      if (iflag.eq.2) then
	infile(8:9)='ln'
	outfile(10:11)='ln'
	endif
      if (iflag.eq.3) then
	infile(8:9)='us'
      	outfile(10:11)='us'
 	endif
      if (iflag.eq.4) then
	infile(8:9)='ls'
 		outfile(10:11)='ls'
 	endif
      OPEN(11,FILE=INFILE,action='READ')
	   	OPEN(12,FILE=OUTFILE)
C 199901  6.85   424.3    4
  121 FORMAT(1X,A4,A2,1X,F5.2,1X,F7.1,1X,I4)
  122	FORMAT(A6)
  123	FORMAT(12(1X,I4))
  124	FORMAT(A64)

C Cycle on years 1999-2015
	iyyyy=1998
C
	do KK=1,17
      iyyyy=iyyyy+1
	call blet4(iyyyy,AYEAR)
	AYR=AYEAR(3:4)
	read(ayr,*) ryr
	iyr=int(ryr)
C  Cycle on mn
C
	imnend=12
	if (iyyyy.eq.2015) imnend=6 ! June 2015
C
	do 55 imn=1,imnend	 ! <<<<<<<<<<<<<<<<<<<<<<<<
C Monthly count of occurrence
  	READ (11,121,END=3,ERR=2) AYEAR,AMN,woc,sw,ncnt
	if (woc.eq.0.) goto 55
C
	rmn=float(imn)
	ASTR=ryr+rmn/12.
	if(iyr.lt.30) then
	ASTR=ASTR+2000.
	else
	ASTR=ASTR+1900.
	endif
C Select Sol Phase boundaries
	do j=1,6
	if ((ASTR.le.RMIN(j)).and.(ASTR.ge.RMAX(j))) then
	AMIN=RMIN(j)
	AMAX=RMAX(j)
	goto 149
	endif
	enddo
	do j=1,5
	if ((ASTR.ge.RMIN(j)).and.(ASTR.le.RMAX(j+1))) then
	amin=RMIN(j)
	amax=rmax(j+1)
	exit
	endif
	enddo
C end select
  149     FI=(ASTR-AMIN)/(AMAX-AMIN)
C
c	num=keq(imn)
c	if (num.eq.0) goto 151
  150 write(*,13) AYEAR,AMN,fi,woc,sw,ncnt
	write(12,13) AYEAR,AMN,fi,woc,sw,ncnt
  13  FORMAT(1X,A4,A2,1X,F7.2,1X,F5.2,1X,F7.1,1X,I4)
  151	continue
  55	continue          !<<<<<<<<<<<<<<<<<<<<<<<<	   ! end cycle on month
	ENDDO					   ! end cycle on year
    3	CLOSE(unit=11)
	CLOSE(unit=12)
c	goto 180
	goto 1
    2	write(*,*) 'input error'
	
180   continue
	pause ' '
      STOP
	end