      program calm3000
C.................................................Nov 2022
C calculate M3000 from foF2, hmF2
C iclude SOCO,FOEEDI, subm3000
C input: foF2, hmF2, cov,xlati, ST
C output M3000 (00,01,...,23 UT) 

	CHARACTER*2 STR,STI,STSIN(2),STSOU(2),AYR,AMN,ADY,CYR,CMN,CDY
	CHARACTER*64 infilef,infileh
C--	+,infileti,infiletr
     +,infilekp
	+,outfilef,outfileh,outfilem
	dimension glats(2),glons(2) ! at, wz
	+,fin(0:23),hin(0:23),fout(0:23),hout(0:23),xmout(0:23)
C--	+,tin(0:23),tres(0:23)
     +,iresf(0:23),iresh(0:23),iresm(0:23)
      COMMON/CONST/UMR
	DATA STSIN/'nc','pq'/
	DATA STSOU/'at','wz'/
	DATA glats/38.4,52.2/
	DATA glons/23.6,21.1/
C
	      UMR=.0174533
      PHI=3.141593
C
	iyr=22	 !TEmp
	call blet2(iyr,AYR)
	imn=11	 !TEmp
	call blet2(imn,AMN)
	write(*,*) ' Enter idy1,idy2:'
	read(*,*) idy1,idy2
C
       infilekp='d:\web\graf\kp2022'	!Temp
C
	infilef='d:\web\graf\2022\siYRf.br'
	infilef(20:21)=AYR
	infileh=infilef
	infileh(22:22)='h'
c--	infileti=infilef
c--	infileti(22:22)='t'
c--	infiletr=infileti
	 outfilef='d:\web\graf\2022\srYRf.br'	!Temp
	outfilef(20:21)=AYR
      outfileh=outfilef
	outfileh(22:22)='h'
	outfilem=outfilef
	outfilem(22:22)='m'
C
   30	format(3I2,59X,F6.2)
   31	format(3A2,24(1X,F4.1))
   32	format(3A2,24(1X,F4.0))

C
	OPEN(10,file=infilekp,action='READ')
    1 read(10,30,end=50) kyr,kmn,kdy,cov
	if ((kyr.eq.iyr).and.(kmn.eq.imn).and.(kdy.eq.idy1)) then
	goto 50
	         else
	goto 1
	       endif
C
   50 close(10)
C
         DO 100 ist=1,2
	sti=stsin(ist)
	str=stsou(ist)
	alati=glats(ist)
	abslat=abs(alati)
	along=glons(ist)
      infilef(18:19)=sti
	 infileh(18:19)=sti
c--	infileti(18:19)=sti
c--	infiletr(18:19)=str
	outfilef(18:19)=str
	outfileh(18:19)=str
	outfilem(18:19)=str
C
C
      OPEN(15,file=outfilef,access='APPEND')
	OPEN(16,file=outfileh,access='APPEND')
	OPEN(17,file=outfilem,access='APPEND')
C
   2      DO 101 idy=idy1,idy2
	call blet2(idy,ADY)
	lda=ndoy(iyr,imn,idy)
       OPEN(11,file=infilef,action='READ')
	OPEN(12,file=infileh,action='READ')
c--	OPEN(13,file=infileti,action='READ')
c--	OPEN(14,file=infiletr,action='READ')

C--      DO idd=1,idy
  123	read(11,31,end=51) CYR,CMN,CDY,(fin(k),k=0,23)
	read(12,32,end=52) CYR,CMN,CDY,(hin(k),k=0,23)
	if ((cyr.eq.ayr).and.(cmn.eq.amn).and.(cdy.eq.ady)) then
	goto 150
	         else
	goto 123
	       endif
C--	read(13,31,end=53) CYR,CMN,CDY,(tin(k),k=0,23)
C--	read(14,31,end=54) CYR,CMN,CDY,(tres(k),k=0,23)
C--	ENDDO
 150	CONTINUE
   51	close(11)
   52	close(12)
c--   53	close(13)
c--   54	close(14)
C
	DO iut=0,23
	HOUR=float(iut)
	fout(iut)=fin(iut)
		hout(iut)=hin(iut)
C--	if (ist.eq.1) then
C--	hout(iut)=0.9105*hin(iut)+11.36
C--	fout(iut)=0.8825*fin(iut)+4.402
C--	               else
C--      hout(iut)=0.1965*hin(iut)+207.3
C--	fout(iut)=1.027*fin(iut)-1.163
C--	endif
C
C--	rf=tres(iut)/tin(iut)
c--	xnmres=rf*fin(iut)**2
c--	fout(iut)=sqrt(xnmres)

	CALL SOCO(LDA,HOUR,ALATI,ALONG,SUNDEC,XHI,SAX,SUX)
 	CALL SOCO(LDA,12.0,ALATI,ALONG,SUNDE1,XHINON,SAXNON,SUXNON)

		FOE=FOEEDI(COV,XHI,XHINON,ABSLAT)
	fof2=fout(iut)
	hmf2=hout(iut)
	call subm3000(foE,foF2,hmf2,xm3)
	xmout(iut)=xm3
	iresf(iut)=nint(fof2*10.)
	iresh(iut)=nint(hmf2)
	iresm(iut)=nint(xm3*100.)
	ENDDO         ! cycle UT
C
C Output of results
       write(*,33) AYR,AMN,ADY,(iresf(k),k=0,23)
	write(*,33) AYR,AMN,ADY,(iresh(k),k=0,23)
	write(*,33) AYR,AMN,ADY,(iresm(k),k=0,23)
       write(15,33) AYR,AMN,ADY,(iresf(k),k=0,23)
	write(16,33) AYR,AMN,ADY,(iresh(k),k=0,23)
	write(17,33) AYR,AMN,ADY,(iresm(k),k=0,23)

  101	CONTINUE
  100	CONTINUE
      close(15)
	close(16)
	close(17)
  33	format(3A2,24(1X,I4))
       pause ' '
	STOP
	END
C ------------------------------------------------------
      REAL FUNCTION FOEEDI(COV,XHI,XHIM,XLATI)
C-------------------------------------------------------
C CALCULATES FOE/MHZ BY THE EDINBURGH-METHOD.      
C INPUT: MEAN 10.7CM SOLAR RADIO FLUX (COV), GEOGRAPHIC
C LATITUDE (XLATI/DEG), SOLAR ZENITH ANGLE (XHI/DEG AND 
C XHIM/DEG AT NOON).
C REFERENCE: 
C 	KOURIS-MUGGELETON, CCIR DOC. 6/3/07, 1973
C 	TROST, J. GEOPHYS. RES. 84, 2736, 1979 (was used
C		to improve the nighttime varition)
C D.BILITZA--------------------------------- AUGUST 1986.    
      COMMON/CONST/UMR
C variation with solar activity (factor A) ...............
      A=1.0+0.0094*(COV-66.0)                      
C variation with noon solar zenith angle (B) and with latitude (C)
      SL=COS(XLATI*UMR)
	IF(XLATI.LT.32.0) THEN
		SM=-1.93+1.92*SL                             
		C=23.0+116.0*SL                              
 	ELSE
	 	SM=0.11-0.49*SL                              
	 	C=92.0+35.0*SL  
  	ENDIF
	if(XHIM.ge.90.) XHIM=89.999
	B = COS(XHIM*UMR) ** SM
C variation with solar zenith angle (D) ..........................        
 	IF(XLATI.GT.12.0) THEN
		SP=1.2
	ELSE
		SP=1.31         
	ENDIF
C adjusted solar zenith angle during nighttime (XHIC) .............
      XHIC=XHI-3.*ALOG(1.+EXP((XHI-89.98)/3.))   
      D=COS(XHIC*UMR)**SP       
C determine foE**4 ................................................
      R4FOE=A*B*C*D     
C minimum allowable foE (sqrt[SMIN])...............................
      SMIN=0.121+0.0015*(COV-60.)
      SMIN=SMIN*SMIN
      IF(R4FOE.LT.SMIN) R4FOE=SMIN                     
      FOEEDI=R4FOE**0.25                           
      RETURN          
      END   
c
