      program cntmnwoc
C.....................................................Apr.2013
C calculation of monthly mean for daily-hourly peak occurrence of W=+-3, W=+-4 index
C Daily peak Probability of occurrence, P%, is defined
C input: hourly Oc*100, 
C from peak Ocmax of hourly (UT) of W-storm occurremce P=Ocmax/100 %
	character*48 infile,outfilyr,outfilmn,txt
		CHARACTER*2 AYR,KYR,KMN,KDY
	INTEGER*2 JYR,JJ
	dimension tec(0:24)
	+,im(12)
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
	infile='wjtocYR.txt'   ! monthly occurrence of storm W-index on map 
	outfilmn='wocmn.txt'
      OPEN(110,FILE=OUTFILMN)
	outfilyr='wprobYR.txt'
C
	 do 51 jj=99,112
	 jyr=jj
	if (jyr.gt.99) jyr=jyr-100
	call blet2(jyr,AYR)
	outfilyr(6:7)=AYR
	OPEN(109,FILE=OUTFILYR)
C
	ryr=float(jyr)
 	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF

	infile(6:7)=AYR
	OPEN(111,FILE=INFILE)
		READ (111,498,END=108,ERR=2) txt ! extra line

  107	FORMAT(3A2,24(1X,F4.2),3X,F4.2)		   
 498  FORMAT(A48)
 499  FORMAT(1X,2A2,1X,F7.2)
 497	FORMAT(1X,3A2,1X,F6.2)
C
	kk=0
	do jmn=1,12	   ! cycle mn-to-mn
	ndays=im(jmn)

	wpmn=0.
	do jdy=1,ndays
	READ (111,107,END=108,ERR=2) KYR,KMN,KDY,(tec(k),k=0,24)
	peak=0.
	   do k=0,23
	   if (tec(k).gt.peak) peak=tec(k)
	   enddo
c	pdy=peak/100.
	pdy=peak
	wpmn=wpmn+pdy
	write(*,497) kyr,kmn,kdy,pdy
	write(109,497) kyr,kmn,kdy,pdy
	enddo
	pmn=wpmn/ndays
	 	WRITE(*,499) kyr,kmn,pmn
 	WRITE(110,499) kyr,kmn,pmn
	enddo		   ! end mn-to-mn

  108 close(unit=111)
	close(unit=109)
  51  CONTINUE ! end yr-to-yr cycle
      close(unit=110)
	goto 15
   2	write(*,*) ' Error'
   15 pause ' '
	stop
	end
	