C.......................................................Feb. 2020
C
C.......................................................Jan 2013
C updated pW+ and pW- 
C New t0= onset of Vsw-min storm
C
C.......................................................May 2013
C Calculate cross-correlation of 2 arrays given lag=-6,-5,-4,...-1,0,1,...5, 6 hrs
C Model of Prpb. W+, W- versus Dst
C 
      program croslag3s
C      output	cmaprms2.txt
C
      DIMENSION dinp1(0:71),dinp2(0:71),x(72),y(72),z(72)
	character*45 infile1,infile2,outfile
c	character*14 title
c
c
	infile1='medsws.txt'
C      infile2='medaes.txt'
C      infile2='medaus.txt'
C      infile2='medals.txt'
C      infile2='medkps.txt'
C      infile2='medaps.txt'
C      infile2='medaas.txt'
C      infile2='medwps.txt'
C++      infile2='medwpps.txt'
C++      infile2='medwpns.txt'
      infile2='meddsts.txt'

		outfile='croslag3_s-.txt'

   21	format(1X,F4.0)
C
   18	OPEN(11,FILE=infile1,action='READ')
      OPEN(12,FILE=infile2,action='READ')
	OPEN(10,FILE=outfile,ACCESS='APPEND')
	do i=0,71
	read(11,*) dinp1(i) ! Vsw
	read(12,*) dinp2(i) ! AE
	dinp2(i)=-dinp2(i)  ! Dst++++++++++++++
	enddo
      close(unit=11)
	close(unit=12)
	do n=0,71
	x(n+1)=dinp1(n)		   !Vsw
	enddo
	do n=0,71
	y(n+1)=dinp2(n)	   ! AE
	enddo

Cycle on lag (delay of Wp after Dst)
	irun=0
  119	continue
	irun=irun+1 
C+      DO 120 lag=0,12
C+      DO 120 lag=0,15
      DO 120 lag=0,24
      nrun=72-lag
	sx=0.
	sy=0.
	do jj=1,nrun
	sx=sx+x(jj)
	z(jj)=y(jj+lag)
C	sy=sy+y(jj)
	sz=sz+z(jj)
	enddo
	sx=sx/nrun
C	sy=sy/nrun
	sz=sz/nrun
	sum1=0.
	sum2=0.
	sum3=0.
	do jj=1,nrun
C	sum1=sum1+(x(jj)-sx)*(z(jj)-sy)
	sum1=sum1+(x(jj)-sx)*(z(jj)-sz)
      sum2=sum2+(x(jj)-sx)**2
C      sum3=sum3+(y(jj)-sy)**2
      sum3=sum3+(z(jj)-sz)**2
	enddo
	cxy=sum1/sqrt(sum2*sum3)
	write(*,22) irun,nrun,lag,cxy,x(1),y(1),z(1)
	write(10,22) irun,nrun,lag,cxy,x(1),y(1),z(1)
  120	continue
C
  22	format(1X,3(1X,I2),1X,F7.3,3(1X,F8.3))
	if (irun.eq.1) then
	do m=0,71
	z(m+1)=dinp1(m)
	x(m+1)=dinp2(m)
	y(m+1)=z(m+1)
	enddo
	goto 119
	else
	 GOTO 33
	endif

    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34
   33	continue
  98	close(unit=10)
      write(*,*) infile1,infile2,outfile
      pause ' ' 
   34   STOP
       END

