C........................................................May.2019
C Extract fixed TEC and Vs-index from JPLi 15-min files (1 x 1 deg) for 0: 23:00 UT
C  long-input from longs=-179.5:1:179.5
C  lati input from lats -89.5:1:89.5
C input Vs : D:\web\drs\YR\MN\vlMNDDUTMM.jYR index file
C output <extjplivt.txt>
C 
      PROGRAM extjplivt
C----------------------------------------------------------------
C
      integer itc(360),ivs(360),IM(12)
C
	CHARACTER*2 AYR,AMN,ADY,AUT,AMM
      CHARACTER*128 INFILE1,INFILE2,OUTFILE
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/ 
C++
C
      ICALLS=0
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
C 
	infile1='D:\UTEC\20YR\MN\tiMNDDUTMM.jYR' !TEC JPLI
	infile2='D:\web\drs\YR\MN\vlMNDDUTMM.jYR' !Vsigma
C
 	outfile='extjplivt.txt'
C
   30 FORMAT(1X,2A2,2(1X,I2),2(1X,F6.1))
   31 FORMAT(360(1X,I4))
C
	OPEN(10,file=outfile,access='APPEND')
C
C Year-by-year cycle
C++	DO 200 iyr=0,17
	iyr=14  ! temp
	call blet2(iyr,AYR)
		z1=iyr/4.0
      jz=int(z1)*4
	IF(jz.EQ.iyr) THEN
               IM(2)=29
	ndnr=366
        ELSE
                IM(2)=28
	  	ndnr=365
	       ENDIF
C
	infile1(11:12)=AYR
	infile1(29:30)=AYR
	infile2(12:13)=AYR
	infile2(30:31)=AYR
C
C Monthly cycle
C++      DO 201 imn=1,12
       imn=3  ! Temp
	call blet2(imn,AMN)
	infile1(14:15)=AMN
	infile1(19:20)=AMN
	infile2(15:16)=AMN
	infile2(20:21)=AMN
C
	idy=15 ! Temp
C-	if ((iyr.eq.0).and.(imn.eq.1)) idy1=15
C-	idy2=im(imn)
C day-to-day cycle
C-       DO 40 idy=idy1,idy2
	CALL blet2(idy,ADY)
	infile1(21:22)=ADY
	infile2(22:23)=ADY
C
C UT cycle
	DO 201 iut=0,23
	call blet2(iut,AUT)
	infile1(23:24)=AUT
	infile2(24:25)=AUT
C
C Minute cycle
	DO 40 imm=0,45,15
	call blet2(imm,AMM)
	infile1(25:26)=AMM
	infile2(26:27)=AMM

C
	OPEN(11,file=infile1,action='READ')
	OPEN(12,file=infile2,action='READ')
C
      xlat=-90.5
C lati cycle
C	DO nlat=1,180
	DO nlat=1,90  ! lati=0! Temp
	xlat=xlat+1.0
	read(11,31,end=46) (itc(k),k=1,360)
	read(12,31,end=47) (ivs(k),k=1,360)
	enddo
	tres=float(itc(360))/10.
	ivlres=ivs(360)
C
c       xlon=179.5 ~ 180E TEMP
c      xlon=-180.5
c	DO 140 nlon=1,360
c	xlon=xlon+1.0
c	if (ivs(nlon).eq.0.) goto 140
c	if (ivs(nlon).gt.0) then
c	      cposdy=cposdy+1.
c      vposdy=vposdy+ivs(nlon)
c	                     else
c	      cnegdy=cnegdy+1.
c      vnegdy=vnegdy+ivs(nlon)
c	endif					! +++
C  140	CONTINUE	   ! 
C
C
	write(*,32) AYR,AMN,ADY,AUT,AMM,tres,ivlres
	write(10,32) AYR,AMN,ADY,AUT,AMM,tres,ivlres
   46		 close(unit=11)
   47		 close(unit=12)
   40 CONTINUE		 ! Minute cyclew
  201 continue  ! UT cycle
  200 continue ! year
	close(unit=10)
C
   32 FORMAT(1X,3A2,2(1X,A2),1X,F6.2,1X,I4)
   35      write(*,*) infile1,infile2,outfile
      pause ' ' 
      STOP
       END

C***********************************************************
