C					                                  Dec. 2013
C
C       Count median pW+ Pw- Dst AE for intense and moderate storm 
C add average excluding values = 0.
C input file for given YR,MN,DY
	program extrmedxx
	DIMENSION CC(240,73),av(73),imed(73)
	+,ix(73),ires(73),tres(73)
	character*75 infile,outfile
      COMMON /BL1/CC,AV
C
	coef=1.
         write(*,*) 'infile:'
	 read(*,*) infile
C	outfile='ae1med.out'
	outfile=infile
	outfile(8:10)='out'
	OPEN(10,file=infile)
	OPEN(11,file=outfile,access='APPEND')
	iix=-25
	do i=1,73
	iix=iix+1
	ix(i)=iix
	imed(i)=0
	tres(i)=0.
	cc(nn,i)=0.
	enddo
  	write(*,103) (ix(k),k=1,73)
	write(11,103) (ix(k),k=1,73)

  101	format(A7,A6,F6.3)
  102	format(1X,A7,1X,F6.2,1X,F6.3)
  103	format(73(1X,I4))
  104	format(73(1X,F4.0))

	nn=0
C	   line-to-line cycle
	DO kk=1,240
	nn=nn+1
C
	read(10,104,err=2,end=21) (cc(kk,i),i=1,73)
	do j=1,73
	if (cc(kk,j).lt.0.) then
	coef=-1.
	cc(kk,j)=cc(kk,j)*coef 
	endif

	enddo
	ENDDO
   21	close(unit=10)
C
	call submedxx(nn,IMED)
	if (coef.gt.0.) goto 17
	do j=1,73
	imed(j)=imed(j)*(-1)
	enddo
  17	write(*,103) (imed(k),k=1,73)
	write(11,103) (imed(k),k=1,73)
C produce average excluding =0.
	do m=1,73
	sum=0.
	cnt=0.
	do n=1,nn
	if (cc(n,m).gt.0.) then
	cnt=cnt+1.
	sum=sum+cc(n,m)
	endif
	enddo
	tres(m)=sum/cnt
	ires(m)=nint(tres(m))
	if (coef.lt.0.) ires(m)=ires(m)*(-1)
	enddo
		write(*,103) (ires(k),k=1,73)
	write(11,103) (ires(k),k=1,73)
	goto 3
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY ',infile
 
   3	pause ' '
		close(unit=11)
	stop
	END
C----------------------------------------------------------------
      subroutine submedxx(nnn,IMED)
C
C
C
      DIMENSION av(73)
	+,CC(240,73)  ! calculate med for xx lines
	+,IMED(73) ! results of median 
			COMMON /BL1/CC,AV
c
c
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
	call smedianx(nnn)
	  	do lon=1,73
	imed(lon)=nint(av(lon))
	    enddo
 
  108 format(3A2,24(1X,I4))	! 
  109 format(73(1X,I4))	! 
      
C
 1234	continue  !
   34 RETURN
       END

C=========================================================================
c VERIFICATION OF MEDIAN ================
      subroutine smedianx(ndnr)
C Input file: CC(ndnr,73) for ndnr lines, 73 columns
C
C Output array: SME(73) 
	DIMENSION CC(240,73),SME(73),X1(240),X2(240)
		COMMON /BL1/CC,SME
C "MEDIAN:"
       DO 1030 M=1,73
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
      IF (CD1.LT.XD1) THEN 
	XMD=X2(ND2)
	else
	XMD=(X2(ND1)+X2(ND2))/2.
	ENDIF
C
 1020 SME(M)=XMD
 1030 CONTINUE
c
 1050 RETURN
      END
C=============================================================================