C					                                  Aug. 2013
C
C       Count 7-days median TEC(UT) for single station TEC 
C input file for given YR,MN,DY
	program extrtec1
	REAL HHMMSS
	DIMENSION im(12),CC(7,0:23),av(0:23),imed(0:23)
	+,ires(0:23)
	character*2 ayr,amn,ady,aut,amm,ass
	character*4 stat
	character*7 ADDYY
	character*6 ATEC
	character*75 infile,outfile,txt,outfile1
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
	integer*2 iyr,imn,idy,iut
      COMMON /BL1/CC,AV
C
	    write(*,*) 'ENTER stat:'
	 read(*,*) stat
	    write(*,*) 'ENTER YR:'
	 read(*,*) AYR
       write(*,*) 'ENTER MN:'
	 read(*,*) AMN
		read(ayr,*) yr
		read(amn,*) rmn
	nn=0
C	   day-to-day cycle
	DO nda=1,7
	nn=nn+1
	imn=int(rmn)
       write(*,*) 'ENTER DY:'
	 read(*,*) ADY
		read(ady,*) rdy
	idy=int(rdy)
C
 	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
	ndnr=im(imn)
 	infile='statYYMMDD.txt'
	infile(1:4)=stat
	infile(5:6)=AYR
	infile(7:8)=AMN
	infile(9:10)=ADY

C	outfile='statyymmdd.dat'
	outfile=infile
	outfile(12:14)='dat'
	outfile1='statyrmn.dat'
	outfile1(7:8)=AMN
	infile(5:6)=AYR
	OPEN(10,file=infile)
crem	OPEN(11,file=outfile)
	OPEN(12,file=outfile1,access='APPEND')
	if (nn.eq.1) write(12,*) stat
C
	do i=0,23
	imed(i)=0
	cc(nn,i)=0.
	enddo
  101	format(A7,A6,F6.3)
  102	format(1X,A7,1X,F6.2,1X,F6.3)
  103	format(24(1X,I4))
  104	format(A75)
	read(10,104) txt
crem	write(11,104) txt
	write(12,104) txt
	read(10,104) txt
crem	write(11,104) txt
C
	do kk=1,600
c//	read(10,104) txt
c//	 ADDYY=txt(1:7)

cree	if (txt(15:15).eq.'.') then

	read(10,*,err=2,end=21) ADDYY,HHMMSS,TEC
	goto 30
c	if (HHMMSS(6:6).eq.' ') then
	AUT(1:1)='0'
	AUT(2:2)=txt(8:8)
	AMM=txt(9:10)
	ASS=txt(11:12)
	ATEC=txt(13:18)
c	else
	AUT=txt(8:9)
	AMM=txt(10:11)
	ASS=txt(12:13)
	ATEC=txt(14:19)
c	endif
	read(aut,*) rut
	read(amm,*) rmm
	read(ass,*) rss
   30	rut=hhmmss/10000.
	iut=int(rut)
	resut=float(iut)
	rmm=(hhmmss-resut*10000.)/100.
	imm=int(rmm)
	resmm=float(imm)
	rss=hhmmss-resut*10000.-resmm*100.
	rmm=resmm+rss/60.
	rmad=rmm/60.
	rut=resut+rmad
c	read(ATEC,*) tec
	write(*,102) ADDYY,rut,tec
crem	write(11,102) ADDYY,rut,tec
	 iut=int(rut)
	xut=float(iut)
	 if(abs(rut-xut).lt.0.0005) then
	 cc(nn,iut)=tec
	 endif 
	enddo
   21	close(unit=10)
	ENDDO               ! end day-to-day cycle
C
	call submed7(IMED)
	do ndy=1,7
	do k=0,23
	ires(k)=nint(cc(ndy,k)*10.)
	enddo
	write(*,103) (ires(k),k=0,23)
	write(12,103) (ires(k),k=0,23)
	enddo
	write(12,*) ' median7'
	write(*,103) (imed(k),k=0,23)
	write(12,103) (imed(k),k=0,23)
crem	write(11,103) (imed(k),k=0,23)
	goto 3
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY ',infile
 
   3	pause ' '
crem	close(unit=11)
		close(unit=12)
	stop
	END
C----------------------------------------------------------------
      subroutine submed7(IMED)
C
C      output	fcYYMMUT.mut; hcYYMMUT.mut; tcYYMMUT.mut;
C
      DIMENSION av(0:23)
	+,CC(7,0:23)  ! calculate med for 7 days
	+,IMED(0:23) ! results of median 
			COMMON /BL1/CC,AV
c
c
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
	call smedian1(7)
	  	do lon=0,23
	imed(lon)=nint(av(lon)*10.)
	    enddo
 
  108 format(3A2,24(1X,I4))	! 
  109 format(73(1X,I4))	! 
      
C
 1234	continue  !
   34 RETURN
       END

C=========================================================================
c VERIFICATION OF MEDIAN ================
      subroutine smedian1(ndnr)
C Input file: CC(ndnr,0:72) for ndnr days, longitudes -180:5:180
C Number days for median : ndnr=7
C Output array: SME(0:72) for longitudes -180:5:180
	DIMENSION CC(7,0:23),SME(0:23),X1(7),X2(7)
		COMMON /BL1/CC,SME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
      IF (CD1.LT.XD1) THEN 
	XMD=X2(ND2)
	else
	XMD=(X2(ND1)+X2(ND2))/2.
	ENDIF
C
 1020 SME(M)=XMD
 1030 CONTINUE
c
 1050 RETURN
      END
C=============================================================================