      program extsmf2
C .........................................................June 2016
C Extract IONEX grids from SMF2 hmF2 results (Shubin, hmF2)
C
      DIMENSION hinp(91),hmap(71,0:72),col(71),sglat(71),glatinp(91)
	+,ires(0:72)
	CHARACTER*40 infile,outfile
      CHARACTER*4 AYEAR,txt
	CHARACTER*2 AMN,AYR
	glat=-90.
	do k=1,71
	glat=glat+2.5
	sglat(k)=glat  !IONEX lats -87.5:2.5:87.5
	enddo
	glat=-92.
	do k=1,91
	glat=glat+2.0
	glatinp(k)=glat  !INPUT lats -90.0:2.0:90.0
	enddo
C
	infile='yearmn12ut.txt'
	outfile='hmMN0012.uYR'	  !SMF2 UT map
   1	write(*,*) 'Enter AYEAR, AMN, AMN=00 for stop '
	read(*,*) AYEAR,AMN
	if (amn.eq.'00') stop
	AYR=AYEAR(3:4)
      infile(1:4)=AYEAR
	infile(5:6)=AMN
      outfile(3:4)=AMN
      outfile(11:12)=AYR
	OPEN(10,file=infile,action='READ')
	OPEN(11,file=outfile)
C
   30 format(A4)
C Read data long-by-long, save in IONEX glat = -87.5:2.5:87.5
	xlong=-195.
	DO 101 lon=0,24
	xlong=xlong+15.
	lon3=lon*3
	read(10,*) clong
c-	DO i=1,6
   2	read(10,30) txt ! extra lines
      if (txt.eq.' -90') then
	backspace(10)
	goto 3
	else
	goto 2
	endif
c-	enddo
   3	DO jj=1,91
	read(10,31) ilat,hinp(jj) ! input lats -90:2:90
	enddo
C Interpolate for IONEX glats
      DO kk=1,71
	glat=sglat(kk)

	do k=1,90
	if ((glat.ge.glatinp(k)).and.(glat.lt.glatinp(k+1))) then
	hmf2=hinp(k)+(hinp(k+1)-hinp(k))/2.*(glat-glatinp(k))
	col(kk)=hmF2
	exit
	endif
	enddo

	hmap(kk,lon3)=col(kk)

	ENDDO
  101	CONTINUE
      close(unit=10)
C
C Interpolate in glongs for -180:5:180
C 
        DO 103 lat=1,71
       glon=-185.
	DO 102 lon=0,23
	glon=glon+5.
	lon3=lon*3
	lon1=lon3+1
	lon2=lon1+1
	dh=(hmap(lat,lon3+3)-hmap(lat,lon3))/3.
	hmap(lat,lon1)=hmap(lat,lon3)+dh
	hmap(lat,lon2)=hmap(lat,lon3)+dh*2.
  102	continue
        do k=0,72
	ires(k)=int(hmap(lat,k))
	enddo
	write(*,32) (ires(k),k=0,72)
	write(11,32) (ires(k),k=0,72)
  103	 CONTINUE
      close(unit=11)
	GOTO 1
   31 format(I4,1X,F6.2)
   32 format(73(1X,I4))
	stop
	END
