      program ionow1
C...........................................................Dec 2022
C
C..............................................................May 2021
C 
C Produce W(foF2) index for Iono-foF2 stations using -27day median
C
C	sites(288)
	character*76 indate                               ! Tamara
	dimension im(12)
     +,glats(80),glons(80)
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*56 txt3,txt4,txt6
	CHARACTER*16 txt2,txt5
	CHARACTER*7 txt1
	CHARACTER*1 ac
	CHARACTER*4 AYEAR,YEAR_pre
	CHARACTER*2 AYR,AMN,DD2,AMN_pre,ADY_pre,DY1,DY2,sts(80),st
	CHARACTER*13 STATS(80),STAT,TIME
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA STS/
     + 'as','at','bc','bp','br','cb','ch','cn','cq','cs'
     +,'cw','jb','db','dw','eg','eb','di','gr','gu','ha' !
     +,'he','ho','jj','jm','jr','kk','lm','ml','mo','mq'
     +,'mw','nd','ni','ok','pe','pq','sa','rm','ro','vt' !
     +,'sq','tv','tr','wk','wp','wz','mm','tk','kg','mg'	
     +,'sd','rv','tz','ns','so','gm','ei','gg','if','tu'	!
     +,'pa','fz','ff','kh','au','al','ga','nc','yg','ic'	!
     +,'ad','bb','bl','sv','mh','sj','sp','cj','er','ll'/	
C      
	DATA STATS/										  !
     + 'Ascension.   ','Athens.      ','Boulder.     '  !
     +,'Beijing.     ','Brisbane.    ','Canberra.    '  !
     +,'Chilton.     ','Camden.      ','Chongqing.   '  !
     +,'Cocos_Is.    ','Casey.       ','Jang_Bogo.   '  !    
     +,'Dourbes.     ','Darwin.      ','Eglin.       '  !
     +,'Roquetes.    ','Dikson.      ','Grahamstown. '   !
     +,'Guangzhou.   ','Hainan.      ','Hermanus.    '  !
     +,'Hobart.      ','Jeju.        ','Jicamarca.   '  !
     +,'Juliusruh.   ','Kokubunji.   ','Learmonth.   '  !
     +,'Manzhouli.   ','Moscow.      ','MacQuarue_Is.'  !
     +,'Mawson.      ','Niue.        ','Norfolk_Is.  '  !
     +,'Okinawa.     ','Perth.       ','Pruhonice.   '  !
     +,'Sao_Luis.    ','Ramey.       ','Rome.        '  !	
     +,'San_Vito.    ','Scott_Base.  ','Townsville.  '  !
     +,'Tromso.      ','Wakkanai.    ','Wallops.     '  !
     +,'Warsaw.      ','Murmansk.    ','Tomsk.       '  !
     +,'Kaliningrad. ','Magadan.     ','Salekhard.   '  !
     +,'Rostov.      ','Tunguska.    ','Novosibirsk. '  !
     +,'Sodankyla.   ','Gibilmanna.  ','Eielson.     '  !	
     +,'Guam.        ','Idaho_NL.    ','Tucuman.     '  !
     +,'Pt_Arguello. ','Fortaleza.   ','Fairford.    '  !
     +,'Khabarovsk.  ','Austin.      ','Alpena.      '  !
     +,'Gakona.      ','Nicosia.     ','Yamagawa.    '  !
     +,'I_Cheon.     ','Ashkhabad.   ','Bahia_Blanca.'  !
     +,'Belem.       ','Sverdlovsk.  ','MillstonHill.'  !
     +,'San_Juan.    ','Sopron.      ','Cachoeira.   ' ! 
     +,'Eareckson.   ','Lualualei.   '/           !
C
	DATA GLATS/
     +  -7.9, 38.4, 40.0, 40.0,-27.5,-35.3, 51.6,-34.0, 29.5,-12.2
     +,-66.3,-74.6, 50.1,-12.2, 30.4, 40.8, 73.5,-33.3, 23.1, 18.3  !
     +,-34.4,-42.9, 33.5,-12.0, 54.6, 35.7,-21.8, 49.6, 55.5,-54.5
     +,-67.6,-19.1,-29.0, 26.3,-32.0, 50.0, -2.6, 18.5, 41.8, 40.6  !
     +,-77.9,-19.7, 69.7, 45.4, 37.8, 52.2, 68.0, 56.5, 54.7, 60.0
     +, 66.5, 47.2, 61.6, 54.6, 67.4, 37.6, 64.7, 13.6, 43.8,-28.3 ! 
     +, 34.8, -3.9, 51.7, 48.5, 30.4, 45.1, 62.4, 35.0, 29.2, 37.1 !
     +, 37.9,-38.7, -1.4, 56.4, 42.6, 18.5, 47.7,-22.7, 52.7, 21.4/ !
      DATA GLONS/
     + 345.6, 23.6,254.7,116.3,152.9,149.1,358.7,150.7,106.4, 96.8
     +,110.5,164.2,  4.6,130.9,273.3,  0.5, 80.4, 26.5,113.4,109.3   !
     +, 19.2,147.2,126.5,283.1, 13.4,139.5,114.1,117.5, 37.3,159.0
     +, 62.9,190.1,168.0,127.8,115.9, 14.6,315.8,292.8, 12.5, 16.7  ! 
     +,166.8,146.9, 19.0,141.7,284.5, 21.1, 33.0, 84.9, 20.6,151.0
     +, 66.5, 39.7, 90.0, 83.2, 26.6, 14.1,212.9,144.9,247.3,333.1 !	
     +,239.5,321.6,358.2,135.1,262.3,276.4,215.0, 33.2,129.6,127.5  !
     +, 58.3,297.7,311.6, 58.6,288.5,294.0, 16.6,315.0,185.9,201.8/ !
C
	COMMON /BL2/STAT,AYEAR,AMN_pre,AMN,DY1,DY2,GLATK,GLONK		 !
C
      ac='c' ! for all pre_days // ac='a' for current day
	txt1='W-index'
      txt2='Date of issue:  '
      txt3='YYMMDD|UT 0    1    2    3    4    5    6    7    8    9'
	txt4='   10   11   12   13   14   15   16   17   18   19   20 '
	txt5='  21   22   23  '  
      txt6='--------------------------------------------------------'
c
	      CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
C
      indate='d:/web/graf/date'    !!! Tamara !!!!!!!	 !
C++	indate='/var/www/izmiran/ionosphere/weather/graf/date'   !!! Liuba !!!!!!!	 !                             !!! Liuba

	open(10,file=indate)							   !
	read(10,799) AYEAR,AMN,DD2,YEAR_pre,AMN_pre,ADY_pre
	WRITE(*,798) AYEAR, AMN, DD2,YEAR_pre,AMN_pre,ADY_pre
	close(unit=10)
  798	format(' YEAR, AMN, DD2 = ',A4,2(1X,A2),1X,A4,2(1X,A2))
  799	format(A4,2(1X,A2),1X,A4,2(1X,A2))				 !
C
	AYR=AYEAR(3:4)
	DY2=DD2                !
	DY1=ADY_pre
      TT(5:)='      '
	TIME=tt(1:4)
	read(DD2,*) rdy
	nrd=int(rdy)      ! current day
C
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
C==	infigs='IGS-sites2.txt'
C==	OPEN(10,file=infigs,action='READ')
	icnt=0
   30	format(A76)
   31	format(A4,A60,F6.2,1X,F7.2)
   32	format(A4,A60,1X,A7,2X,'glat ='F6.2,1X,'glon ='F7.2)        ! txt1=TECU
   33	format(2A56,A16,1X)
   34	format(3A2,1X,24(I4,1X))
   35	format(A16,A4,2A2,1X,'Time = ',A4,1X)
C
   15	FORMAT(A2)
C
	read(ayr,*) yr
	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	ndnr=366
	                          ELSE
	IM(2)=28
	ndnr=365
	ENDIF
C
	read(amn,*) xmn
	imn=int(xmn)
	ndmn=im(imn)
C
C  ============ Cycle on IGS sites ==================
C
	DO 41 ist=1,80  ! Cycle on sites
	st=sts(ist)
	stat=STATS(ist)
	glatk=glats(ist)
	glonk=glons(ist)

C
C W(foF2) calculation
C
      call subdevfof2(st)    ! DEVLOG, W(NMF2)
C
   41	CONTINUE
	
C	pause ' '  !!! Liuba 
	STOP 
	END